/*---------------------------------------------------------------------------
|  Program  na  fitovani   reflexni krivky drsne multivrstvy                |
|  s uvazenim nekorelovanych rozhrani                                       |
|  drsnost - Gaussovo rozdeleni                                             |
|  Pouzivaji se analyticke derivace                          Verze 2.5      |
|  moznost kompilace pod GNU C                                              |
|                                                                         |
|				Mojmir  Meduna    12.1.2000                 |
|                                                                           |
----------------------------------------------------------------------------*/

#include<stdio.h>
#include<stdlib.h>
#include<conio.h>
#include<Complex.h>
#include<math.h>
#ifdef __TURBOC__
  #include <alloc.h>
  #include<graphics.h>
#endif
#ifndef __TURBOC__
  #define M_PI 3.14159265359
  #include<iostream.h>
#endif
#include <dos.h>   // pouze kvuli funkci delay

#include "pmcomplx.h"
#include "marqfitp.h"

   int POCET;          // POCET = pocet vrstev

   const int PocetDat = 1000; // NumDat;  // pocet "experimentalnich" dat
   const int KolikPrint = 1;  // 0 pro zadny, 1 kazdy, 2 kazdy druhy...
   const delaytime=0; // chces-li vypocet trochu pozdrzet

   #define AnalDerivace    // define: bude se brat analyticka derivace
// #define AnalDerivace  // undefine: bude se brat numericka derivace

   Complex Im = Complex(0,1);  // Imag. jednotka

   typedef char * charvector;
   typedef double * dvector;
   typedef Complex * cvector;
   typedef Complex matrix[2][2];
   typedef matrix  * matrvec;
   typedef Complex (* complvec)[2];
   typedef Complex  vector[2];

   char inpfile[255];   // Soubor s vstupnimi fitovanymi daty
   char soubor[255];    // Vystupni soubor s nafitovanou krivkou
   char string[15];
   char in;
   char out;            //Vystup
   char fit;	      // Provest fitovani
   char sum;            //Provest zasumeni pri simulaci
   char backfit;        //Fitovat pozadi
   int  ips;             //integracni doba
   char jedn;

   charvector fitr, fitd, fitdns;
   dvector d, dmin, dmax;              // Tloustka vrstvy
   dvector dens, densmin, densmax;     // Relativni hustota
   dvector delta, beta, rougth, rougmin, rougmax;
   cvector n;

   double lambda;      // lambda = vln. delka
   double begf, endf;  // Obor fitovani
   int pocet;          // Skutecny pocet vrstev
   int NumDat;         // Skutecny pocet dat
   int NumPar;         // Pocet fitovanych parametru
   double iprim, iback, diver, bx, by, sx, sy, dist, slit;
   double sumavah;
   double lback, hback;

   const int NPAR=30;//3*(POCET+1);       // Pocet parametru
   parfloat B[NPAR+1],Bmin[NPAR],Bmax[NPAR+1];  // npar+1 (pole je od jednicky)
   int pfit[NPAR+1];
   int I, J;
   datafloat X[PocetDat+1], Y[PocetDat+1], Vaha[PocetDat+1];
   datafloat SumR;
   int Eval; // boolean

// Definice objektu s funkci, jez se bude fitovat, se provede pomoci
//  naslednika TMarq takhle:

   class
   TMyMarq: virtual public TMarq {
   public:
      TMyMarq (const char* aTraceFile, int AShowErrors):
      TMarq(aTraceFile,AShowErrors) { 
      }; // konstruktor
      TMyMarq (): TMarq("tracefit.dat",1) { 
      } ; // implicitni konstruktor
   protected:
      virtual datafloat FitFun
      ( datafloat X, parfloat *B, int& Fres );
      #ifdef AnalDerivace
      virtual void DoJac ( int I, datafloat *X, parfloat *B,
                        parfloat *D, int& dres );
      virtual void Residue ( datafloat& Res, int& Suc,
                        datafloat *X, datafloat *Y, datafloat *Vaha, parfloat *B );
      #endif
      // kdybych neumel spocitat derivaci, tak bych tuhle proceduru
      // sem nepridal a pouzivala by se numericka derivace
   };

   void UkazVysledky ( TMarq *M ) {
      cout <<"\nVysledky:\n";
      cout<<"Residuum="<<SumR<<"      Eval="<<Eval
         #ifdef ElaTime
         <<"    Cas: "<<M->GetElapsedTime(1)
         #endif
         ; cout<<"  Pocet iteraci: "<<M->citer<<'\n';
      for (I=1; I<=NumPar; I++)
         cout<<"Nafitovany parametr c. "<<I<<" je: "<<B[I]
            <<" +- "<<sqrt( M->GetSigma(I) )<<'\n';
      cout<<"Pozadi = "<<iback;
      if (backfit=='a') cout<<" +- "<<sqrt(M->GetDisperze()/sumavah)*iprim<<"\n";
      else cout<<"\n";
      cout<<"Press any key for Korel. koef. \n"; getch();
      cout<<"Korelacni koeficienty:\n";
      for (I=1; I<=NumPar; I++) {
         cout<<I;
         for (J=1; J<=I; J++) cout<<"  "<<M->GetKorelKoef(I,J);
         cout <<'\n'; };
      cout <<"Disperze na jedn. vahy = "<<M->GetDisperze()<<'\n';
   };


   void ShowMemory() {
   #ifdef __TURBOC__
   cout<<"\nThe difference between the highest allocated block in the far\n";
   cout<<"heap and the top of the far heap is: "<<farcoreleft()<<" bytes\n";
   cout<<"The difference between the highest allocated block and\n";
   cout<<"the top of the heap is "<<coreleft()<<" B\n\n";
   #endif
   }

   void nas (matrix a, matrix b, matrix& c)    // Nasobeni matic
   {
      int i, j, k;
   
      for (i = 0; i<2; i++)  {
         for (j = 0; j<2; j++) {
            c[i][j] = 0;
            for (k = 0; k<2; k++)
               c[i][j] =c[i][j] + a[i][k] * b[k][j];
         }
      }
   }


   Complex det(matrix a)      //Determinant matice
   {
      return(a[0][0]*a[1][1]-a[0][1]*a[1][0]);
   }


   double GAMMA(double x)   // Gamma funkce
   {
      double  stp = 2.50662827465,
         half= 0.5,
         one = 1.0,
         fpf = 5.5;
      double  cof[6] = {76.18009173,-86.50532033,24.01409822,
         -1.231739516,0.120858003e-2,-0.536382e-5};
      int i,j;
      double xx, tmp, ser, gam;
   
      i = 0;
      if (x < 1) {x += 1; i = 1;
      }
      xx = x-one;  tmp = xx+fpf;  tmp = (xx+half)*log(tmp)-tmp;
      ser = one;
      for (j =0;j < 6;j++) {
         xx += one;  ser += cof[j]/xx;
      }
      gam = exp(tmp+log(stp*ser));
   
      if (i == 1) gam = gam/(x-1);
   
      return(gam);
   }


   Complex chi(double rougthness, Complex q) // Charakteristicka funkce
   {
   
      Complex W, x;
   
      x = rougthness*q;
      W = exp(-0.5*pow(x,2));    // Gausovo rozdeleni
      return(W);
   }


   Complex dchids(double rougthness, Complex q) // derivace char. funkce
   {                                            // podle drsnosti
   
      Complex W, x;
   
      x = rougthness*q;
      W = -rougthness*q*q*exp(-0.5*pow(x,2));    // Gausovo rozdeleni
      return(W);
   }


   Complex dchidq(double rougthness, Complex q) // derivace char. funkce
   {                                            // podle vln. vektoru
   
      Complex W, x;
   
      x = rougthness*q;
      W = -pow(rougthness,2)*q*exp(-0.5*pow(x,2));    // Gausovo rozdeleni
      return(W);
   }


		     // Realna reflektivita
   double reflexe(double lambda,double thr,int pocet,
                 cvector n,dvector d,dvector rougth)
   {
      int i, j;
      double k0 = 2*M_PI/lambda;    // vln vektor ve vakuu
      double thrad;               //uhel dopadu v rad
      Complex th;                 // komplex uhel dopadu
      Complex Reflex, Transmis;             // odrazivost, transmise
      cvector kz;   // z slozka vln. vektoru v i-te vrstve
      cvector fip, fim; // fazove cleny  exp(+-Im*kz*d)
      cvector r, t; // Fresnelovy koeficienty i-teho rozhrani
      matrvec Ri;    // reflex. matice s charakter fcemi
      matrvec Fi_1;  // fazova matice
      matrvec B;
      complvec E;
      Complex T0;
   
      if ((kz = (cvector) malloc(sizeof(Complex)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((fip = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((fim = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((r = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((t = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((Ri = (matrvec) malloc(4*sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((Fi_1 = (matrvec) malloc(4*sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((B = (matrvec) malloc(4*sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((E = (complvec) malloc(2*sizeof(Complex)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
   
      thrad = (jedn == 'v') ? thr*M_PI/648000 : thr*M_PI/180;   // prevod z vterin na rad
      th = Complex(thrad,0);
      for (i = 0; i <= pocet+1; i++) {
         kz[i] = k0*sqrt(pow(n[i],2)-pow(n[0]*cos(th),2));
      }
      for (i = 0; i < pocet; i++) {
         r[i] = (kz[i]-kz[i+1])/(kz[i]+kz[i+1]);
         t[i] = 1+r[i];
         fip[i+1] = exp(+Im*kz[i+1]*d[i+1]);
         fim[i+1] = 1/fip[i+1];
         Ri[i][0][0] = chi(rougth[i],kz[i]-kz[i+1]);
         Ri[i][0][1] = r[i]*chi(rougth[i],kz[i+1]+kz[i]);
         Ri[i][1][0] = r[i]*chi(rougth[i],-kz[i+1]-kz[i]);
         Ri[i][1][1] = chi(rougth[i],kz[i+1]-kz[i]);
         Fi_1[i+1][0][0] = fip[i+1];
         Fi_1[i+1][0][1] = 0;
         Fi_1[i+1][1][0] = 0;
         Fi_1[i+1][1][1] = fim[i+1];
         nas(Ri[i],Fi_1[i+1],B[i]);
      }
      free(fim); free(fip); free(Fi_1);
   
      r[i] = (kz[i]-kz[i+1])/(kz[i]+kz[i+1]);
      t[i] = 1+r[i];
      B[i][0][0] = Ri[i][0][0] = chi(rougth[i],kz[i]-kz[i+1]);
      B[i][0][1] = Ri[i][0][1] = r[i]*chi(rougth[i],kz[i+1]+kz[i]);
      B[i][1][0] = Ri[i][1][0] = r[i]*chi(rougth[i],-kz[i+1]-kz[i]);
      B[i][1][1] = Ri[i][1][1] = chi(rougth[i],kz[i+1]-kz[i]);
   
      free(r); free(t); free(Ri);
   
      E[pocet+1][0] = 100;  E[pocet+1][1] = 0;
      for (i = pocet; i>=0; i--) {
         E[i][0] = E[i+1][0]*B[i][0][0]+E[i+1][1]*B[i][0][1];
         E[i][1] = E[i+1][0]*B[i][1][0]+E[i+1][1]*B[i][1][1];
      }
      Reflex = (E[0][0] == 0) ? Complex(1,0): E[0][1]/E[0][0];
      T0 = E[0][0];
   
      free(kz); free(B); free(E);
   
      return(pow(abs(Reflex),2));
   }

		  // Opravny faktor na rozmer vzorku a paprsku
   double vzorek(double thr, double bx, double by, double sx, double sy)
   {
      double bpl, spl, rx, ry, bs,thrad ,factor;
   
      if (thr != 0) {
         thrad = (jedn == 'v') ? thr*M_PI/648000 : thr*M_PI/180;   // prevod z vterin na rad
         bs = bx/sin(thrad);
         rx = (bs < sx) ? bs : sx;
         ry = (by < sy) ? by : sy;
         spl = rx*ry;
         bpl = bs*by;
         factor = spl/bpl;
      }
      else factor = 0;
      return(factor);
   }


	// Oprava na primar zasahujici do vzorku pri malych uhlech
   double primar(double thr, double bx, double sx, double dist, double slit)
   {                      // Predp. ze sterbina je sirsi nez primar
      double pdet, sxx, pom, pr;   // justace do 1/2 primaru
      double thrad;
      thrad = (jedn == 'v') ? thr*M_PI/648000 : thr*M_PI/180;   // prevod z vterin na rad
      pdet = dist*sin(2*thrad)-slit/2;
      sxx = sx/2*sin(thrad);
      if ((sxx < bx/2) && (pdet < bx/2)) {
         pom = (sxx > pdet) ? sxx : pdet;
         pr = (bx/2-pom)/bx;
      }
      else
         pr = 0;
      return(pr);
   }


   datafloat TMyMarq::FitFun( datafloat X, parfloat *B, int& Fres ) {
   
      int i, c, f;
      datafloat pom, res;
   
      Fres=1;
   #ifndef __GNUC__
      delay(delaytime); // jinak by se to spocitalo prilis rychle, kdyby nebyl vystup na obrazovku
   #endif
      for (i = 1;i <= NumPar;i++) {
         c = (int)pfit[i]/3;
         f = pfit[i]-3*c;
         switch (f) {
            case 2:      d[c+1] = B[i]; 
               break;
            case 1:   dens[c+1] = B[i]; 
               break;
            case 0: rougth[c] = B[i]; 
               break;
         }
      }
      for (i = 0;i <= pocet+1;i++) {
         n[i] = Complex(1-delta[i]*dens[i],-beta[i]*dens[i]);
      }
      if (diver != 0) {
         pom = reflexe(lambda,X-diver/2,pocet,n,d,rougth);
         pom += reflexe(lambda,X+diver/2,pocet,n,d,rougth);
         pom /=2;
      }
      else
         pom = reflexe(lambda,X,pocet,n,d,rougth);
   
      pom *= vzorek(X,bx,by,sx,sy);
      pom += primar(X,bx,sx,dist,slit);
      res = pom+iback/iprim;
   
      return res;
   }

#ifdef AnalDerivace
   void TMyMarq::DoJac
   ( int I, datafloat *X, parfloat *BB, parfloat *D, int& dres ) {
   
      int ii, jj, c, f;
      parfloat Der[2][NPAR];
   
      int i, j, m, p, k, l;
      double k0 = 2*M_PI/lambda;    // vln vektor ve vakuu
      double thr ,thrad;
      Complex th, x;                 // komplex uhel dopadu
      cvector kz;   // z slozka vln. vektoru v i-te vrstve
      cvector fip, fim; // fazove cleny  exp(+-Im*kz*d)
      cvector r, t; // Fresnelovy koeficienty i-teho rozhrani
      matrvec Ri;//[POCET+1];    // reflex. matice s charakter fcemi
      matrvec Fi_1;//[POCET+1];  // fazova matice
      matrvec B;
      matrix M, pom, pom1, C,dBaj, dBaj_1, dFij, dRi, dRi_1;
      vector E1, E2, R;
      complvec E;//[POCET+2][2];
      Complex dX, XX;
      Complex T0;
   
      if ((kz = (cvector) malloc(sizeof(Complex)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((fip = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((fim = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((r = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((t = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((Ri = (matrvec) malloc(4*sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((Fi_1 = (matrvec) malloc(4*sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((B = (matrvec) malloc(4*sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((E = (complvec) malloc(2*sizeof(Complex)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
   
      for (ii = 1;ii <= NumPar;ii++) {
         c = (int)pfit[ii]/3;
         f = pfit[ii]-3*c;
         switch (f) {
            case 2:      d[c+1] = BB[ii]; 
               break;
            case 1:   dens[c+1] = BB[ii]; 
               break;
            case 0: rougth[c] = BB[ii]; 
               break;
         }
      }
      for (ii = 0;ii <= pocet+1;ii++) {
         n[ii] = Complex(1-delta[ii]*dens[ii],-beta[ii]*dens[ii]);
      }
   
   
      thr = X[I]-diver/2;
   
      p=0;
      do{
      
         thrad = thr*M_PI/648000;   // prevod z vterin na rad
         th = Complex(thrad,0);
         for (i = 0; i <= pocet+1; i++) {
            kz[i] = k0*sqrt(pow(n[i],2)-pow(n[0]*cos(th),2));
         }
         for (i = 0; i < pocet; i++) {
            r[i] = (kz[i]-kz[i+1])/(kz[i]+kz[i+1]);
            t[i] = 1+r[i];
            fip[i+1] = exp(+Im*kz[i+1]*d[i+1]);
            fim[i+1] = 1/fip[i+1];
            Ri[i][0][0] = chi(rougth[i],kz[i]-kz[i+1]);
            Ri[i][0][1] = r[i]*chi(rougth[i],kz[i+1]+kz[i]);
            Ri[i][1][0] = r[i]*chi(rougth[i],-kz[i+1]-kz[i]);
            Ri[i][1][1] = chi(rougth[i],kz[i+1]-kz[i]);
            Fi_1[i+1][0][0] = fip[i+1];
            Fi_1[i+1][0][1] = 0;
            Fi_1[i+1][1][0] = 0;
            Fi_1[i+1][1][1] = fim[i+1];
            nas(Ri[i],Fi_1[i+1],B[i]);
         }
         r[i] = (kz[i]-kz[i+1])/(kz[i]+kz[i+1]);
         t[i] = 1+r[i];
         B[i][0][0] = Ri[i][0][0] = chi(rougth[i],kz[i]-kz[i+1]);
         B[i][0][1] = Ri[i][0][1] = r[i]*chi(rougth[i],kz[i+1]+kz[i]);
         B[i][1][0] = Ri[i][1][0] = r[i]*chi(rougth[i],-kz[i+1]-kz[i]);
         B[i][1][1] = Ri[i][1][1] = chi(rougth[i],kz[i+1]-kz[i]);
      
      
         E[pocet+1][0] = 1;  E[pocet+1][1] = 0;
         for (i = pocet; i>=0; i--) {
            E[i][0] = E[i+1][0]*B[i][0][0]+E[i+1][1]*B[i][0][1];
            E[i][1] = E[i+1][0]*B[i][1][0]+E[i+1][1]*B[i][1][1];
         }
         XX= E[0][1]/E[0][0];
         T0 = E[0][0];
      
      
      
      //---Zacatek cyklu derivaci ------------------
      
         for (ii = 1;ii <= NumPar;ii++) {
            c = (int)pfit[ii]/3;
            f = pfit[ii]-3*c;
         
            k = (f == 0) ? c : c+1;
            l = f;
         
         
         //----- Vypocet intenzit E(k+1) a E(k-1) -----------
         
            m=0;
            if (l == 0 && k != pocet) {k++; m=1;} //Pro drsnost je k = k+1
            if (l == 1 && k == pocet+1) {k--; m=-1;}
            if (l == 1 && k == 0) {k++; m=2;}
         
            E2[0]=E[k+1][0];
            E2[1]=E[k+1][1];
         
            E1[0]=E[k-1][0];
            E1[1]=E[k-1][1];
         
            if (l == 1 && m == -1) k++;
            if (l == 1 && m == 2) k--;
            if (l == 0 && m==1) k--;
         
         
         
         //------ Vypocet vlastnich derivaci-------------------
            switch (l) {
               case 2: 
                  {
                     for (i = 0; i<2; i++) {            // Prirazeni dBaj = 0
                        for (j = 0; j<2; j++) {
                           dBaj[i][j] = 0;
                        }
                     }
                     dFij[0][0] = Im*kz[k]*fip[k]; dFij[0][1] = 0;
                     dFij[1][0] = 0; dFij[1][1] = -Im*kz[k]*fim[k];
                     nas(Ri[k-1],dFij,dBaj_1);
                  }
                  break;
               case 1: 
                  {
                     if (k != pocet+1 && k != 0) {
                        dRi[0][0] = dchidq(rougth[k],kz[k]-kz[k+1]);
                        dRi[0][1] = r[k]*dchidq(rougth[k],kz[k+1]+kz[k])+
                           chi(rougth[k],kz[k+1]+kz[k])*2*kz[k+1]/pow(kz[k]+kz[k+1],2);
                        dRi[1][0] = -r[k]*dchidq(rougth[k],-kz[k+1]-kz[k])+
                           chi(rougth[k],-kz[k+1]-kz[k])*2*kz[k+1]/pow(kz[k]+kz[k+1],2);
                        dRi[1][1] = -dchidq(rougth[k],kz[k+1]-kz[k]);
                        if (k != pocet) {
                           nas(dRi,Fi_1[k+1],dBaj);
                        }
                        else {
                           for (i = 0; i<2; i++) {           // Prirazeni dBaj = 0
                              for (j = 0; j<2; j++) {
                                 dBaj[i][j] = dRi[i][j];
                              }
                           }
                        }
                     }
                     else {
                        if(k == pocet+1) {
                           k--;
                           dBaj[0][0] = -dchidq(rougth[k],kz[k]-kz[k+1]);
                           dBaj[0][1] = r[k]*dchidq(rougth[k],kz[k+1]+kz[k])+
                              -chi(rougth[k],kz[k+1]+kz[k])*t[k]/(kz[k]+kz[k+1]);
                           dBaj[1][0] = -r[k]*dchidq(rougth[k],-kz[k+1]-kz[k])+
                              -chi(rougth[k],-kz[k+1]-kz[k])*t[k]/(kz[k]+kz[k+1]);
                           dBaj[1][1] = dchidq(rougth[k],kz[k+1]-kz[k]);
                           k++;
                        }
                        else {
                           for (i = 0; i<2; i++) {            // Prirazeni dBaj = 0
                              for (j = 0; j<2; j++) {
                                 dBaj[i][j] = 0;
                              }
                           }
                        }
                     }
                  
                     if (k != pocet+1) {
                        if (l == 1 && k == 0) {k++; m=2;}
                     
                        dRi_1[0][0] = -dchidq(rougth[k-1],kz[k-1]-kz[k]);
                        dRi_1[0][1] = r[k-1]*dchidq(rougth[k-1],kz[k]+kz[k-1])+
                           chi(rougth[k-1],kz[k]+kz[k-1])*-t[k-1]/(kz[k-1]+kz[k]);
                        dRi_1[1][0] = -r[k-1]*dchidq(rougth[k-1],-kz[k]-kz[k-1])+
                           chi(rougth[k-1],-kz[k]-kz[k-1])*-t[k-1]/(kz[k-1]+kz[k]);
                        dRi_1[1][1] = dchidq(rougth[k],kz[k]-kz[k-1]);
                        nas(dRi_1,Fi_1[k],pom);
                     
                        if (l == 1 && m == 2) k--;
                     
                        if (m != 2) {
                           dFij[0][0] = Im*d[k]*fip[k]; dFij[0][1] = 0;
                           dFij[1][0] = 0; dFij[1][1] = -Im*d[k]*fim[k];
                           nas(Ri[k-1],dFij,pom1);
                        }
                        else {
                           for (i = 0; i<2; i++) {            // Prirazeni dBaj = 0
                              for (j = 0; j<2; j++) {
                                 pom1[i][j] = 0;
                              }
                           }
                        }
                     }
                     else {
                        for (i = 0; i<2; i++) {            // Prirazeni dBaj = 0
                           for (j = 0; j<2; j++) {
                              pom1[i][j] = pom[i][j] = 0;
                           }
                        }
                     }
                  
                     for (i = 0; i<2; i++) {            // Prirazeni dBaj = 0
                        for (j = 0; j<2; j++) {
                           dBaj_1[i][j] = pom[i][j]+pom1[i][j];
                        }
                     }
                  }
                  break;
               case 0: 
                  {
                     if (k < pocet) {
                        for (i = 0; i<2; i++) {            // Prirazeni dBaj = 0
                           for (j = 0; j<2; j++) {
                              dBaj[i][j] = 0;
                           }
                        }
                        dRi[0][0] = dchids(rougth[k],kz[k]-kz[k+1]);
                        dRi[0][1] = r[k]*dchids(rougth[k],kz[k+1]+kz[k]);
                        dRi[1][0] = r[k]*dchids(rougth[k],-kz[k+1]-kz[k]);
                        dRi[1][1] = dchids(rougth[k],kz[k+1]-kz[k]);
                        nas(dRi,Fi_1[k+1],dBaj_1);
                     }
                     else {
                        for (i = 0; i<2; i++) {            // Prirazeni dBaj = 0
                           for (j = 0; j<2; j++) {
                              dBaj_1[i][j] = 0;
                           }
                        }
                        dBaj[0][0] = dchids(rougth[k],kz[k]-kz[k+1]);
                        dBaj[0][1] = r[k]*dchids(rougth[k],kz[k+1]+kz[k]);
                        dBaj[1][0] = r[k]*dchids(rougth[k],-kz[k+1]-kz[k]);
                        dBaj[1][1] = dchids(rougth[k],kz[k+1]-kz[k]);
                     }
                  }
                  break;
               default :
                  break;
            }
         
         
            if (l == 0 && k < pocet) k++; //Pro drsnost je k = k+1
            if (l == 1 && k == pocet+1) k--; //Pro index lomu substratu je k = k-1
            if (l == 1 && k == 0) {k++; m=2;}
         
            nas(B[k-1],dBaj,pom);   // Vypocty matice C
            if (k < pocet+1) nas(dBaj_1,B[k],pom1);
         
            for (i = 0; i<2; i++) {            // Prirazeni C = pom + pom1
               for (j = 0; j<2; j++) {
                  C[i][j] = pom[i][j] + pom1[i][j];
               }
            }
         
         // Skalarni soucin intenzit s matici C
            dX = E1[0]*(E2[0]*C[1][0]+E2[1]*C[1][1])-E1[1]*(E2[0]*C[0][0]+E2[1]*C[0][1]);
            for (i = 0;i <= k-2;i++) dX *= det(B[i]);
            dX /=(T0*T0);
         
            if (l == 1 && m==-1) k++;
            if (l == 0 && m==1) k--; //Pro drsnost je k = k+1
            if (l == 1 && m == 2) k--;
         
            if (l == 1) dX *= (k != 0) ? k0*k0*n[k]/kz[k]*(-delta[k]-Im*beta[k])
                  : kz[k]/n[k]*(-delta[k]-Im*beta[k]);
         
            Der[p][ii] = 2*real(dX*conj(XX));
         
         }
      //-----------Konec cyklu derivaci ------------------
      
         p++;
         thr +=diver;
      }
      while (diver != 0 && p<2);
   
      if (diver != 0) {
         for (ii=1; ii<=NumPar; ii++) {  // Derivace pri divergenci primaru
            D[ii] = (Der[0][ii]+Der[1][ii])/2;
         }
      }
      else {
         for (ii=1; ii<=NumPar; ii++) {
            D[ii] = Der[0][ii];    //derivace bez divergence
         }
      }
   
   
      cfitfun += NumPar; dres = 1;
   
      free(kz); free(fim); free(fip); free(r); free(t); free(Ri);
      free(Fi_1); free(B); free(E);
   
   
   }

   void TMyMarq::Residue ( datafloat& Res, int& Suc,
                     datafloat *X, datafloat *Y, datafloat *Vaha, parfloat *B )
   {
   // Vraci hodnotu Res rezidualniho souctu ctvercu r'.r pro dane b;
   //  (' zde i v dalsim znaci transpozici). Dale spocte vektor residui R
      int I=0;
      datafloat sum, moc ,disp;
      Res=0; sum=0; Suc=1; ++cresid;
      while (Suc && ( I<n_dat ))
      {
         _Indx_Mr=(++I);
         D0[I]=FitFun(X[I],B,Suc); cfitfun++;
      //save pro num. derivaci. Jede i ve FormMat!!!
         R[I]=D0[I]-Y[I];
      //   _MarqRez[I]=R[I];
         moc = Vaha[I]*(-R[I]+iback/iprim);
         sum += moc;
         Res += Vaha[I]*(R[I]*R[I]);
      }
      if (backfit == 'a') iback = (sum>=0) ? iprim*sum/sumavah : 0.1;
      if (iback < lback) iback=lback;
      if (iback > hback) iback=hback;
   
      disp = Res/(NumDat-NumPar);
      cout<<"Pozadi = "<<iback;
      if (backfit=='a') cout<<" +- "<<sqrt(disp/sumavah)*iprim<<"\n";
      else cout<<"\n";
   
   }
#endif

#ifdef __TURBOC__
   void grafi(double th0,double thmax,double logmin,double logmax)
   {
   
      double thr, s;
      char text[60];
   //-----------------Inicializace grafiky --------------------------
   
   /* request auto detection */
      int gdriver = DETECT, gmode, errorcode;
   
   /* initialize graphics mode */
      initgraph(&gdriver, &gmode, "D:COMPILE\BC31\BGI");
   
   /* read result of initialization  */
      errorcode = graphresult();
   
      if (errorcode != grOk)  /* an error occurred */
      {
         printf("Graphics error: %s\n", grapherrormsg(errorcode));
         printf("Press any key to halt:");
         getch();
         exit(1);             /* return with error code */
      }
   // ----------------------Konec inicializace ---------------------------
   
   // Osy grafu
      for (s = 0; s < 1; s+=0.001) putpixel(s*getmaxx(),getmaxy(),15);
      for (s = 0; s < 1; s+=0.001) putpixel(0,getmaxy()*(1.0-s)/(1.0-0),15);
      for (s = 0; s < 1; s+=0.01) putpixel(getmaxx()*(begf-th0)/(thmax-th0),getmaxy()*(1.0-s)/(1.0-0),2);
      for (s = 0; s < 1; s+=0.01) putpixel(getmaxx()*(endf-th0)/(thmax-th0),getmaxy()*(1.0-s)/(1.0-0),2);
   
   
      char uhl_jedn[3];
      sprintf(uhl_jedn,"%s",(jedn=='v') ? "\"" : "deg");
      sprintf(text,"%1.0lf %s",th0,uhl_jedn);
      outtextxy(0.03*getmaxx(),0.98*getmaxy(),text);
      sprintf(text,"%1.0lf %s",thmax,uhl_jedn);
      outtextxy(0.90*getmaxx(),0.98*getmaxy(),text);
      sprintf(text,"10^%1.1lf",logmin);
      outtextxy(0.005*getmaxx(),0.95*getmaxy(),text);
      sprintf(text,"10^%1.1lf",logmax);
      outtextxy(0.005*getmaxx(),0.01*getmaxy(),text);
      sprintf(text,"Reflexe na multivrstve s drsnymi rozhranimi");
      outtextxy(0.2*getmaxx(),0.03*getmaxy(),text);
      sprintf(text,"Pocet vrstev %1.0d",pocet);
      outtextxy(0.2*getmaxx(),0.05*getmaxy(),text);
      sprintf(text,"Divergence primaru %1.3lf %s",diver,uhl_jedn);
      outtextxy(0.2*getmaxx(),0.07*getmaxy(),text);
   
      setcolor(14);
      sprintf(text,"|R|^2 = f(th) %1.0lf%s< th <%1.0lf%s",th0,uhl_jedn,thmax,uhl_jedn);
      outtextxy(0.5*getmaxx(),0.2*getmaxy(),text);
   
   }


   void grafe()
   {
   // -------------- Uzavreni grafiky ----------------------
      getch();
      closegraph();
   // --------------Uzaveni grafiky ---------------------------
   }
#endif

   void simulace(double th0,double thmax,double logmin,double logmax)
   {
      int i;
      double x, s;
      double thr, pom;
      double step = (thmax-th0)/300;
      FILE *fr;
   
      if (out == 'a') fr = fopen(soubor,"w");
   
      for (i = 0;i <= pocet+1;i++) {
         n[i] = Complex(1-delta[i]*dens[i],-beta[i]*dens[i]);
      }
      for (thr = th0;thr <= thmax;thr+=step) {
         if (diver != 0) {
            pom = reflexe(lambda,thr-diver/2,pocet,n,d,rougth);
            pom += reflexe(lambda,thr+diver/2,pocet,n,d,rougth);
            pom /=2;
         }
         else
            pom = reflexe(lambda,thr,pocet,n,d,rougth);
      
         pom *= vzorek(thr,bx,by,sx,sy);
         pom += primar(thr,bx,sx,dist,slit);
         pom = pom+iback/iprim;
      
         if (sum=='a' && fit=='n') {
            s = 0;
            for (i = 1;i<=16;i++) {
               x = rand();
               x /= 32767;
               s += x;
            }
            s = sqrt(iprim*pom/ips)*(s-8)+iprim*pom; //int. doba = 25*vzork. doba
            pom = (s > 0)  ? s/iprim : pom;
         }
      
         if (out == 'a') {
            if (sum == 'a') fprintf(fr,"%8.3lf %10.15lf %8.3lf\n",thr,pom,ips);
            else  fprintf(fr,"%8.3lf %10.15lf\n",thr,pom);
         }
         pom = log10(pom);
      	#ifdef __TURBOC__
         putpixel(thr/(thmax)*getmaxx(),getmaxy()*(logmax-pom)/(logmax-logmin),14);
      	#endif
      }
      if (out == 'a') fclose(fr);
   }


#ifdef __TURBOC__
   void expdata(double th0,double thmax,double logmin,double logmax,
               datafloat X[PocetDat+1],datafloat Y[PocetDat+1])
   {
      int i;
      for(i = 1;i<=NumDat;i++) {
         if (Y[i]!=0) putpixel((X[i]-th0)/(thmax-th0)*getmaxx(),getmaxy()*(logmax-log10(Y[i]))/(logmax-logmin),13);
      }
   }
#endif

   main()
   {
      int i, j, k, kk, c;
      double refl;
      double thr, thrpom, thr1;   // uhel dopadu
      char ip, cas;
      double intper, intper_1;
      double Xmin, Xmax, Ymin, Ymax;
   
   #ifdef AnalDerivace
      cout<<"Pouziva se ANALYTICKA derivace\n\n";
   #else
   cout<<"Pouziva se NUMERICKA derivace\n\n";
   #endif
      cout << "Press any key...\n"; getch();
   //ShowMemory();
   
      errno = 0;
   
   
   //=================Nacitani vstupnich  hodnot ==============================
   
      FILE *fr, *fw;
      fr = fopen("rk_anfit.inp","r");
      if (errno != 0) {printf("No such input file"); exit(1);}
   
      while ((c = getc(fr)) != '$')
         ;                     	    // nacitani hodnot ze souboru
      fscanf(fr,"%lf", &iprim);           // Intenzita primaru
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf %lf %lf", &iback, &lback, &hback);// Intenzita pozadi
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &backfit);          // Fitovat pozadi
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &diver);           // Divergence primaru
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &bx);              // Rozmer paprsku x
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &by);              // Rozmaer paprsku y
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &slit);            // Sirka sterbiny
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &dist);            // Vzdalenost sterbiny od vzorku
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &sx);              // Rozmer vzorku x
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &sy);              // Rozmer vzorku y
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &lambda);          // Vln. delka
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%s", inpfile);           // Nazev vstupniho souboru s exp. daty
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &in);              // Vstupni data
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%s", soubor);           // Nazev vystupniho souboru
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &out);              // Vystup do souboru
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &fit);              // Provest fitovani
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &sum);              // Zasumet data
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &ips);              // Int. doba pro sum
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &ip);              // Nacitat int. dobu
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &cas);              // Cas nebo int. doba
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &jedn);              // Uhlove jednotky
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &begf);          // Pocatek oboru fit. dat
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &endf);          // Konec oboru fit. dat (ve vt.)
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &Xmin);          // Meze osy X
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &Xmax);          // Meze osy X
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &Ymin);          // Meze osy Y
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &Ymax);          // Meze osy Y
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &POCET);          // Max. pocet vrstev
   
      if ((fitr = (charvector) malloc(sizeof(int)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((fitd = (charvector) malloc(sizeof(int)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((fitdns = (charvector) malloc(sizeof(int)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((d = (dvector) malloc(sizeof(double)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((dmin = (dvector) malloc(sizeof(double)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((dmax = (dvector) malloc(sizeof(double)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((dens = (dvector) malloc(sizeof(double)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((densmin = (dvector) malloc(sizeof(double)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((densmax = (dvector) malloc(sizeof(double)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((delta = (dvector) malloc(sizeof(double)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((beta = (dvector) malloc(sizeof(double)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((rougth = (dvector) malloc(sizeof(double)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((rougmin = (dvector) malloc(sizeof(double)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((rougmax = (dvector) malloc(sizeof(double)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((n = (cvector) malloc(sizeof(Complex)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
   
      k = 0; kk = 0; i=0;
      do {
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%d", &j);
         i = (j >= 0) ? j : i+1;
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%lf %lf", &delta[i], &beta[i]);
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%lf %lf %lf", &rougth[i-1], &rougmin[i-1], &rougmax[i-1]);
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%c",&fitr[i-1]);
         if (fitr[i-1] == 'a') {
            k++;
            B[k] = rougth[i-1];
            Bmin[k] = rougmin[i-1];
            Bmax[k] = rougmax[i-1];
            pfit[k] = kk;
         }
         kk++;
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%lf %lf %lf", &dens[i], &densmin[i], &densmax[i]);
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%c",&fitdns[i]);
         if (fitdns[i] == 'a') {
            k++;
            B[k] = dens[i];
            Bmin[k] = densmin[i];
            Bmax[k] = densmax[i];
            pfit[k] = kk;
         }
         kk++;
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%lf %lf %lf", &d[i], &dmin[i], &dmax[i]);
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%c",&fitd[i]);
         if (fitd[i] == 'a') {
            k++;
            B[k] = d[i];
            Bmin[k] = dmin[i];
            Bmax[k] = dmax[i];
            pfit[k] = kk;
         }
         kk++;
      } while (j >= 0);
      pocet= i-1;     // Pocet vrstev
      NumPar = k;
      fclose(fr);
   
      delta[0] = beta[0] = 0;
   
      if (in == 'a') {
      //========================Nacitani merenych dat ===========================
      
         fr = fopen(inpfile,"r");
         if (errno != 0) {printf("No such data file"); exit(1);}
      
         while ((c = getc(fr)) != '$')
            ;
         for (i=1;i<4;i++) {
            fscanf(fr,"%s\n",string); }
      
         i=0; intper_1 = 0;
         while (feof(fr) == 0) {
            i++;
            switch (ip) {
               case 'a': fscanf(fr,"%22e %22e %22lf \n", &X[i], &Y[i], &intper);
                  break;
               case 'n': fscanf(fr,"%22e %22e \n", &X[i], &Y[i]);
                  break;
            }
            Vaha[i] = (Y[i] != 0) ? 1/Y[i] : 0;
            if (ip == 'a') {
               Vaha[i] *= (cas == 'c') ? intper-intper_1 :intper;
               intper_1 = intper;
            }
            else  {
               refl = Y[i]*iprim;
               if (refl <= 1000) {Vaha[i] *= 2.5;}
               if (refl <= 100) {Vaha[i] *= 2;}
               if (refl <= 10) {Vaha[i] *= 2;}
            }
            if (X[i]<begf || X[i]>endf) {Vaha[i] *= 0;}  // obor fitovani
         }
         NumDat = i-1;      // Pocet fitovanych dat
         fclose(fr);
      
         sumavah=0;        //Vypocet sumy vah
         for (i=1; i<=NumDat; i++) sumavah+=Vaha[i];
      
         #ifdef __TURBOC__
      	grafi(0,X[NumDat],Ymin,Ymax);
      	#endif
         simulace(0,X[NumDat],Ymin,Ymax);
      	#ifdef __TURBOC__
         expdata(0,X[NumDat],Ymin,Ymax,X,Y);
         grafe();
      	#endif
      }
      else {
         #ifdef __TURBOC__
         grafi(Xmin,Xmax,Ymin,Ymax);
      	#endif
         simulace(Xmin,Xmax,Ymin,Ymax);
      	#ifdef __TURBOC__
         expdata(Xmin,Xmax,Ymin,Ymax,X,Y);
         grafe();
      	#endif
      }
   
   
      if (fit == 'a' && in == 'a') {
      
      // ============== fitovani pres potomka TMyMarq ==========
      
         TMyMarq *MyMarq;
         MyMarq = new TMyMarq ("trace.dat",1);  // inicializace fit. objektu
      // tez by to slo inicializovat  MyMarq = new TMyMarq ();
      
      // ted to nafituj
         MyMarq->Marq
            ( NumDat , X,Y,Vaha, NumPar/*pocet parametru*/, B,Bmin,Bmax, SumR, Eval, KolikPrint );
      // v B jsou odhadnute parametry
         UkazVysledky(MyMarq);
         delete MyMarq;  // zavola si destructor
      // uz jsem to nafitoval a zjistil vsechny stat. udaje
      
         cout << "Press any key...\n"; getch();
      
      
         #ifdef __TURBOC__
      	grafi(0,X[NumDat],Ymin,Ymax);
      	#endif
         simulace(0,X[NumDat],Ymin,Ymax);
      	#ifdef __TURBOC__
         expdata(0,X[NumDat],Ymin,Ymax,X,Y);
         grafe();
      	#endif
      }
   
      if (fit == 'a' && in !='a') cout<<"Nenactena vstupni data";
   
   
      free(fitr); free(fitd); free(fitdns); free(d); free(dmax);
      free(dmin); free(dens); free(densmax); free(densmin); free(delta); free(beta);
      free(rougth); free(rougmax); free(rougmin); free(n);
   
      return(c);
   
   }

