/*
---------------------------------------------------------------------------
|  Program  na  fitovani   reflexni krivky drsne multivrstvy                |
|  s uvazenim identickych vrstev                                            |
|  drsnost - Gaussovo rozdeleni                                             |
|  Pouzivaji se numericke derivace                           Verze 2.5      |
|  Moznost kompilace i pod GNU C                                            |
|                                                                           |
|				Mojmir  Meduna    12.1.2000                                     |
|                                                                           |
----------------------------------------------------------------------------*/

#include<stdio.h>
#include<stdlib.h>
#include<conio.h>
#include<Complex.h>
#include<math.h>
#ifdef __TURBOC__
  #include <alloc.h>
  #include<graphics.h>
#endif
#ifndef __TURBOC__
  #define M_PI 3.14159265359
  #include<iostream.h>
#endif
#include <dos.h>   // pouze kvuli funkci delay

#include "pmcomplx.h"
#include "marqfitp.h"

   int POCET;          // POCET = pocet vrstev

   const int PocetDat = 1000; // NumDat;  // pocet "experimentalnich" dat
   const int KolikPrint = 1;  // 0 pro zadny, 1 kazdy, 2 kazdy druhy...
   const delaytime=0; // chces-li vypocet trochu pozdrzet

// #define AnalDerivace    // define: bude se brat analyticka derivace
// #define AnalDerivace  // undefine: bude se brat numericka derivace

   Complex Im = Complex(0,1);  // Imag. jednotka

   typedef char * charvector;
   typedef double * dvector;
   typedef Complex * cvector;
   typedef Complex matrix[2][2];
   typedef matrix  * matrvec;//[POCET+1];
   typedef Complex (* complvec)[2];

   char inpfile[255];   // Soubor s vstupnimi fitovanymi daty
   char soubor[255];    // Vystupni soubor s nafitovanou krivkou
   char string[15];
   char in;
   char out;
   char fit;         // Provest fitovani
   char logfit;
   char sum;
   char backfit;
   int ips;
   char jedn;

   charvector fitr, fitd, fitdns;
   dvector d, dmin, dmax;              // Tloustka vrstvy
   dvector dens, densmin, densmax;     // Relativni hustota
   dvector delta, beta, rougth, rougmin, rougmax;
   cvector n;

   double lambda;      // lambda = vln. delka
   double begf, endf;  // Obor fitovani
   double h;           // koeficient druhu rozdeleni
   int pocet;       // Skutecny pocet vrstev
   int NumDat;      // Skutecny pocet dat
   int NumPar;      // Pocet fitovanych parametru
   double iprim, iback, diver, bx, by, sx, sy, dist, slit;
   double sumavah;
   double lback, hback;

   const int NPAR=70; //3*(POCET+1); // Pocet parametru
   parfloat B[NPAR+1],Bmin[NPAR],Bmax[NPAR+1];  // npar+1 (pole je od jednicky)
   int pfit[NPAR+1];
   int I, J;
   datafloat X[PocetDat+1], Y[PocetDat+1], Vaha[PocetDat+1];
   datafloat SumR;
   int Eval; // boolean

// Definice objektu s funkci, jez se bude fitovat, se provede pomoci
//  naslednika TMarq takhle:

   class
   TMyMarq: virtual public TMarq {
   public:
      TMyMarq (const char* aTraceFile, int AShowErrors):
      TMarq(aTraceFile,AShowErrors) { 
      }; // konstruktor
      TMyMarq (): TMarq("tracefit.dat",1) { 
      } ; // implicitni konstruktor
   protected:
      virtual datafloat FitFun
      ( datafloat X, parfloat *B, int& Fres );
      #ifdef AnalDerivace
      virtual void DoJac ( int I, datafloat *X, parfloat *B,
   	   parfloat *D, int& dres );
      #endif
      virtual void Residue ( datafloat& Res, int& Suc,
                        datafloat *X, datafloat *Y, datafloat *Vaha, parfloat *B );
      // kdybych neumel spocitat derivaci, tak bych tuhle proceduru
      // sem nepridal a pouzivala by se numericka derivace
   };

   void UkazVysledky ( TMarq *M ) {
      cout <<"\nVysledky:\n";
      cout<<"Residuum="<<SumR<<"      Eval="<<Eval
         #ifdef ElaTime
         <<"    Cas: "<<M->GetElapsedTime(1)
         #endif
         ; cout<<"  Pocet iteraci: "<<M->citer<<'\n';
      for (I=1; I<=NumPar; I++)
         cout<<"Nafitovany parametr c. "<<I<<" je: "<<B[I]
            <<" +- "<<M->GetSigma(I)<<'\n';
      cout<<"Pozadi = "<<iback;
      if (backfit=='a' && logfit !=  'g') cout<<" +- "<<sqrt(M->GetDisperze()/sumavah)*iprim<<"\n";
      else cout<<"\n";
      cout<<"Press any key for Korel. koef. \n"; getch();
      cout<<"Korelacni koeficienty:\n";
      for (I=1; I<=NumPar; I++) {
         cout<<I;
         for (J=1; J<=I; J++) cout<<"  "<<M->GetKorelKoef(I,J);
         cout <<'\n'; };
      cout <<"Disperze na jedn. vahy = "<<M->GetDisperze()<<'\n';
   };


   void ShowMemory() {
   #ifdef __TURBOC__
   cout<<"\nThe difference between the highest allocated block in the far\n";
   cout<<"heap and the top of the far heap is: "<<farcoreleft()<<" bytes\n";
   cout<<"The difference between the highest allocated block and\n";
   cout<<"the top of the heap is "<<coreleft()<<" B\n\n";
   #endif
   }

   void nas (matrix a, matrix b, matrix& c)    // Nasobeni matic
   {
      int i, j, k;
   
      for (i = 0; i<2; i++)  {
         for (j = 0; j<2; j++) {
            c[i][j] = 0;
            for (k = 0; k<2; k++)
               c[i][j] =c[i][j] + a[i][k] * b[k][j];
         }
      }
   }

   double GAMMA(double x)   // Gamma funkce
   {
      double  stp = 2.50662827465,
         half= 0.5,
         one = 1.0,
         fpf = 5.5;
      double  cof[6] = {76.18009173,-86.50532033,24.01409822,
         -1.231739516,0.120858003e-2,-0.536382e-5};
      int i,j;
      double xx, tmp, ser, gam;
   
      i = 0;
      if (x < 1) {x += 1; i = 1;
      }
      xx = x-one;  tmp = xx+fpf;  tmp = (xx+half)*log(tmp)-tmp;
      ser = one;
      for (j =0;j < 6;j++) {
         xx += one;  ser += cof[j]/xx;
      }
      gam = exp(tmp+log(stp*ser));
   
      if (i == 1) gam = gam/(x-1);
   
      return(gam);
   }


   Complex chi(double rougthness, Complex q) // Charakteristicka funkce
   {                                       // obecnych rozdeleni
   
      Complex W, x;
   
      x = rougthness*q;
      if (h == 1 || h == 0.5) {
         if (h == 1)
            W = exp(-0.5*pow(x,2));    // Gausovo rozdeleni
         else
            W = 1/(2+pow(x,2));        // Exponencialni rozdeleni
      }
      else {
         int i, num = 100;
         double krok = 0.1;  // Pro h=1/5 lepe krok 0.01 a pro h=1/10 radeji 0.0001
         Complex s;          // Pro 1>h>1/2 dostatecna presnost
         double A, B;        // A*exp(-B*x^(2*h))
         B = GAMMA(3/(2*h))/GAMMA(1/(2*h));   // Vypocet koeficientu pro rozdeleni
         A = h*sqrt(B)/GAMMA(1/(2*h));
         B = pow(B,h);
      
         s = cos(0)*exp(-B*pow(0,2*h));
         for (i =1;i<num;i++) {
            s += 4*cos((2*i-1)*krok*x)*exp(-B*pow((2*i-1)*krok,2*h))+2*cos(2*i*krok*x)*exp(-B*pow(2*i*krok,2*h));
         }
         s += 4*cos((2*i-1)*krok*x)*exp(-B*pow((2*i-1)*krok,2*h))+cos(2*i*krok*x)*exp(-B*pow(2*i*krok,2*h));
         s *= 2*A*krok/3;
         W = s;
      }
   
      return(W);
   }
				// Reflexni v dane poloze
   double reflexe(double lambda,double h,double thr,int pocet,
                 cvector n,dvector d,dvector rougth)
   {
      int i, j;
      double k0 = 2*M_PI/lambda;    /* vln vektor ve vakuu */
      double thrad;
      Complex th;                 /* komplex uhel dopadu */
      Complex Reflex;             /* odrazivost */
      cvector kz;   /* z slozka vln. vektoru v i-te vrstve */
      cvector fip, fim; /* fazove cleny  exp(+-Im*kz*d)  */
      cvector r, t; /* Fresnelovy koeficienty i-teho rozhrani */
      matrvec Ri;    // reflex. matice s charakter fcemi
      matrvec Fi_1;  // fazova matice
      matrvec B;
      complvec E;
      Complex T0;
   
      if ((kz = (cvector) malloc(sizeof(Complex)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((fip = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((fim = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((r = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((t = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((Ri = (matrvec) malloc(4*sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((Fi_1 = (matrvec) malloc(4*sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((B = (matrvec) malloc(4*sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((E = (complvec) malloc(2*sizeof(Complex)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
   
      thrad = (jedn == 'v') ? thr*M_PI/648000 : thr*M_PI/180;   // prevod z vterin na rad
      th = Complex(thrad,0);
      for (i = 0; i <= pocet+1; i++) {
         kz[i] = k0*sqrt(pow(n[i],2)-pow(n[0]*cos(th),2));
      }
      for (i = 0; i < pocet; i++) {
         r[i] = (kz[i]-kz[i+1])/(kz[i]+kz[i+1]);
         t[i] = 1+r[i];
         fip[i+1] = exp(+Im*kz[i+1]*d[i+1]);
         fim[i+1] = 1/fip[i+1];
         Ri[i][0][0] = 1;
         Ri[i][0][1] = r[i];
         Ri[i][1][0] = r[i];
         Ri[i][1][1] = 1;
         Fi_1[i+1][0][0] = fip[i+1];
         Fi_1[i+1][0][1] = 0;
         Fi_1[i+1][1][0] = 0;
         Fi_1[i+1][1][1] = fim[i+1];
         nas(Ri[i],Fi_1[i+1],B[i]);
      }
      free(fim); free(fip);
   
      r[i] = (kz[i]-kz[i+1])/(kz[i]+kz[i+1]);
      t[i] = 1+r[i];
      B[i][0][0] = Ri[i][0][0] = 1;
      B[i][0][1] = Ri[i][0][1] = r[i];
      B[i][1][0] = Ri[i][1][0] = r[i];
      B[i][1][1] = Ri[i][1][1] = 1;
   
      free(r); free(t); free(Ri); free(Fi_1);
   
      E[pocet+1][0] = 100;  E[pocet+1][1] = 0;
      for (i = pocet; i>=0; i--) {
         E[i][0] = E[i+1][0]*B[i][0][0]+E[i+1][1]*B[i][0][1];
         E[i][1] = E[i+1][0]*B[i][1][0]+E[i+1][1]*B[i][1][1];
      }
      Reflex = (E[0][0] == 0) ? Complex(1,0): E[0][1]/E[0][0];
      Reflex *= (h == 1) ? exp(-2*rougth[0]*rougth[0]*kz[0]*kz[pocet+1]) : chi(rougth[0],-kz[0]-kz[pocet+1])/chi(rougth[0],kz[0]-kz[pocet+1]);
      T0 = E[0][0];
   
      free(kz); free(B); free(E);
   
      return(pow(abs(Reflex),2));
   }

		  // Opravny faktor na rozmer vzorku a paprsku
   double vzorek(double thr, double bx, double by, double sx, double sy)
   {
      double bpl, spl, rx, ry, bs,thrad ,factor;
   
      if (thr != 0) {
         thrad = (jedn == 'v') ? thr*M_PI/648000 : thr*M_PI/180;   // prevod z vterin na rad
         bs = bx/sin(thrad);
         rx = (bs < sx) ? bs : sx;
         ry = (by < sy) ? by : sy;
         spl = rx*ry;
         bpl = bs*by;
         factor = spl/bpl;
      }
      else factor = 0;
      return(factor);
   }

	// Oprava na primar zasahujici do vzorku pri malych uhlech
   double primar(double thr, double bx, double sx, double dist, double slit)
   {                      // Predp. ze sterbina je sirsi nez primar
      double pdet, sxx, pom, pr;   // justace do 1/2 primaru
      double thrad;
      thrad = (jedn == 'v') ? thr*M_PI/648000 : thr*M_PI/180;   // prevod z vterin na rad
      pdet = dist*sin(2*thrad)-slit/2;
      sxx = sx/2*sin(thrad);
      if ((sxx < bx/2) && (pdet < bx/2)) {
         pom = (sxx > pdet) ? sxx : pdet;
         pr = (bx/2-pom)/bx;
      }
      else
         pr = 0;
      return(pr);
   }

   datafloat TMyMarq::FitFun( datafloat X, parfloat *B, int& Fres ) {
   
      int i, c, f;
      datafloat pom, res;
   
      Fres=1;
   #ifndef __GNUC__
      delay(delaytime); // jinak by se to spocitalo prilis rychle, kdyby nebyl vystup na obrazovku
   #endif
      for (i = 1;i <= NumPar;i++) {
         c = (int)pfit[i]/2;
         f = pfit[i]-2*c;
         if (c == pocet+1 && f == 0) rougth[0] = B[i];
         else {
            switch (f) {
               case 0:      d[c+1] = B[i]; 
                  break;
               case 1:   dens[c+1] = B[i]; 
                  break;
            //      case 2: rougth[c] = B[i]; break;
            }
         }
      }
   
   //dens[1]=B[1]/d[1];
   
      for (i = 0;i <= pocet+1;i++) {
         n[i] = Complex(1-delta[i]*dens[i],-beta[i]*dens[i]);
      }
      pom = reflexe(lambda,h,X-diver/2,pocet,n,d,rougth);
      pom += reflexe(lambda,h,X+diver/2,pocet,n,d,rougth);
      pom *= vzorek(X,bx,by,sx,sy)/2;
      pom += primar(X,bx,sx,dist,slit);
      res = pom+iback/iprim;
      if (logfit == 'g') res = log10(res);
   
      return res;
   }


   void TMyMarq::Residue ( datafloat& Res, int& Suc,
                     datafloat *X, datafloat *Y, datafloat *Vaha, parfloat *B )
   {
   // Vraci hodnotu Res rezidualniho souctu ctvercu r'.r pro dane b;
   //  (' zde i v dalsim znaci transpozici). Dale spocte vektor residui R
      int I=0;
      datafloat sum, moc ,disp;
      Res=0; sum=0; Suc=1; ++cresid;
      while (Suc && ( I<n_dat ))
      {
         _Indx_Mr=(++I);
         D0[I]=FitFun(X[I],B,Suc); cfitfun++;
      //save pro num. derivaci. Jede i ve FormMat!!!
         R[I]=D0[I]-Y[I];
      //   _MarqRez[I]=R[I];
         moc = Vaha[I]*(-R[I]+iback/iprim);
         sum += moc;
         Res += Vaha[I]*(R[I]*R[I]);
      }
   
      if (logfit !='g') {
         if (backfit == 'a') iback = (sum>=0) ? iprim*sum/sumavah : 0;
         if (iback < lback) iback=lback;
         if (iback > hback) iback=hback;
      
         disp = Res/(NumDat-NumPar);
         cout<<"Pozadi = "<<iback;
         if (backfit=='a') cout<<" +- "<<sqrt(disp/sumavah)*iprim<<"\n";
         else cout<<"\n";
      }
   
   }


#ifdef __TURBOC__
   void grafi(double th0,double thmax,double logmin,double logmax)
   {
   
      double thr, s;
      char text[60];
   //-----------------Inicializace grafiky --------------------------
   
   /* request auto detection */
      int gdriver = DETECT, gmode, errorcode;
   
   /* initialize graphics mode */
      initgraph(&gdriver, &gmode, "D:COMPILE\BC31\BGI");
   
   /* read result of initialization  */
      errorcode = graphresult();
   
      if (errorcode != grOk)  /* an error occurred */
      {
         printf("Graphics error: %s\n", grapherrormsg(errorcode));
         printf("Press any key to halt:");
         getch();
         exit(1);             /* return with error code */
      }
   // ----------------------Konec inicializace ---------------------------
   
   // Osy grafu
      for (s = 0; s < 1; s+=0.001) putpixel(s*getmaxx(),getmaxy(),15);
      for (s = 0; s < 1; s+=0.001) putpixel(0,getmaxy()*(1.0-s)/(1.0-0),15);
      for (s = 0; s < 1; s+=0.01) putpixel(getmaxx()*(begf-th0)/(thmax-th0),getmaxy()*(1.0-s)/(1.0-0),2);
      for (s = 0; s < 1; s+=0.01) putpixel(getmaxx()*(endf-th0)/(thmax-th0),getmaxy()*(1.0-s)/(1.0-0),2);
   
      char uhl_jedn[3];
      sprintf(uhl_jedn,"%s",(jedn=='v') ? "\"" : "deg");
      sprintf(text,"%1.0lf %s",th0,uhl_jedn);
      outtextxy(0.03*getmaxx(),0.98*getmaxy(),text);
      sprintf(text,"%1.0lf %s",thmax,uhl_jedn);
      outtextxy(0.90*getmaxx(),0.98*getmaxy(),text);
      sprintf(text,"10^%1.1lf",logmin);
      outtextxy(0.005*getmaxx(),0.95*getmaxy(),text);
      sprintf(text,"10^%1.1lf",logmax);
      outtextxy(0.005*getmaxx(),0.01*getmaxy(),text);
      sprintf(text,"Reflexe na multivrstve s drsnymi replikovanymi  rozhranimi");
      outtextxy(0.2*getmaxx(),0.03*getmaxy(),text);
      sprintf(text,"Pocet vrstev %1.0d",pocet);
      outtextxy(0.2*getmaxx(),0.05*getmaxy(),text);
      sprintf(text,"Divergence primaru %1.3lf %s",diver,uhl_jedn);
      outtextxy(0.2*getmaxx(),0.07*getmaxy(),text);
   
      setcolor(14);
      sprintf(text,"|R|^2 = f(th) %1.0lf%s< th <%1.0lf%s",th0,uhl_jedn,thmax,uhl_jedn);
      outtextxy(0.5*getmaxx(),0.2*getmaxy(),text);
   
   }

   void grafe()
   {
   // -------------- Uzavreni grafiky ----------------------
      getch();
      closegraph();
   // --------------Uzaveni grafiky ---------------------------
   }
#endif

   void simulace(double th0,double thmax,double logmin,double logmax)
   {
      int i;
      double x, s;
      double thr, pom;
      double step = (thmax-th0)/300;
      FILE *fr;
   
      if (out == 'a') fr = fopen(soubor,"w");
   
      for (i = 0;i <= pocet+1;i++) {
         n[i] = Complex(1-delta[i]*dens[i],-beta[i]*dens[i]);
      }
      for (thr = th0;thr <= thmax;thr+=step) {
         pom = reflexe(lambda,h,thr-diver/2,pocet,n,d,rougth);
         pom += reflexe(lambda,h,thr+diver/2,pocet,n,d,rougth);
         pom *= vzorek(thr,bx,by,sx,sy)/2;
         pom += primar(thr,bx,sx,dist,slit);
         pom = pom+iback/iprim;
      
         if (sum=='a' && fit=='n') {
            s = 0;
            for (i = 1;i<=16;i++) {
               x = rand();
               x /= 32767;
               s += x;
            }
            s = sqrt(iprim*pom/ips)*(s-8)+iprim*pom; //int. doba = 25*vzork. doba
            pom = (s > 0)  ? s/iprim : pom;
         }
      
         if (out == 'a') {
            if (sum == 'a') fprintf(fr,"%8.3lf %10.15lf %8.3lf\n",thr,pom,ips);
            else  fprintf(fr,"%8.3lf %10.15lf\n",thr,pom);
         }
         pom = log10(pom);
      	#ifdef __TURBOC__
         putpixel(thr/(thmax)*getmaxx(),getmaxy()*(logmax-pom)/(logmax-logmin),14);
      	#endif
      }
      if (out == 'a') fclose(fr);
   
   }


#ifdef __TURBOC__
   void expdata(double th0,double thmax,double logmin,double logmax,
               datafloat X[PocetDat+1],datafloat Y[PocetDat+1])
   {
      int i;
      switch (logfit) {
         case 'n': 
            {
               for(i = 1;i<=NumDat;i++) {
                  if (Y[i] !=0) putpixel((X[i]-th0)/(thmax-th0)*getmaxx(),getmaxy()*(logmax-log10(Y[i]))/(logmax-logmin),13);		  }
            }
            break;
         case 'g': 
            {
               for(i = 1;i<=NumDat;i++) {
                  putpixel((X[i]-th0)/(thmax-th0)*getmaxx(),getmaxy()*(logmax-Y[i])/(logmax-logmin),13);
               }
            }
            break;
      }
   
   }
#endif

   void main(void)
   {
      int i, j, k, kk, c;
      double refl;
      char ip, cas;
      double intper, intper_1;
      double Xmin, Xmax, Ymin, Ymax;
   
   #ifdef AnalDerivace
   cout<<"Pouziva se ANALYTICKA derivace\n\n";
   #else
      cout<<"Pouziva se NUMERICKA derivace\n\n";
   #endif
      cout << "Press any key...\n"; getch();
   //ShowMemory();
   
      errno = 0;
   
   
   //============== Nacitani vstupnich hodnot =====================
   
      FILE *fr, *fw;
      fr = fopen("rk_idfit.inp","r");
      if (errno != 0) {printf("No such input file"); exit(1);}
   
      while ((c = getc(fr)) != '$')
         ;                     	    // nacitani hodnot ze souboru
      fscanf(fr,"%lf", &iprim);           // Intenzita primaru
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf %lf %lf", &iback, &lback, &hback);// Intenzita pozadi
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &backfit);          // Fitovat pozadi
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &diver);              // Divergence primaru
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &bx);              // Rozmer paprsku x
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &by);              // Rozmaer paprsku y
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &slit);            // Sirka sterbiny
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &dist);            // Vzdalenost sterbiny od vzorku
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &sx);              // Rozmer vzorku x
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &sy);              // Rozmer vzorku y
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &lambda);          // Vln. delka
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%s", inpfile);           // Nazev vstupniho souboru s exp. daty
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &in);              // Vstupni data
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%s", soubor);           // Nazev vystupniho souboru
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &out);              // Vystup do souboru
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &fit);              // Provest fitovani
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &logfit);              // Fitovat logaritmus
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &sum);              // Zasumet data
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &ips);              // Int. doba pro sum
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &ip);              // Nacitat int. dobu
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &cas);              // Cas nebo int. doba
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &jedn);              // Uhlove jednotky
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &begf);          // Pocatek oboru fit. dat
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &endf);          // Konec oboru fit. dat (ve vt.)
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &Xmin);          // Meze osy X
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &Xmax);          // Meze osy X
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &Ymin);          // Meze osy Y
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &Ymax);          // Meze osy Y
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &POCET);          // Max. pocet vrstev
   
      if ((fitr = (charvector) malloc(sizeof(int)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((fitd = (charvector) malloc(sizeof(int)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((fitdns = (charvector) malloc(sizeof(int)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((d = (dvector) malloc(sizeof(double)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((dmin = (dvector) malloc(sizeof(double)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((dmax = (dvector) malloc(sizeof(double)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((dens = (dvector) malloc(sizeof(double)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((densmin = (dvector) malloc(sizeof(double)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((densmax = (dvector) malloc(sizeof(double)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((delta = (dvector) malloc(sizeof(double)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((beta = (dvector) malloc(sizeof(double)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((rougth = (dvector) malloc(sizeof(double))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((rougmin = (dvector) malloc(sizeof(double))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((rougmax = (dvector) malloc(sizeof(double))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((n = (cvector) malloc(sizeof(Complex)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
   
   
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf %lf %lf", &rougth[0], &rougmin[0], &rougmax[0]);
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c",&fitr[0]);
   
   
      k = 0; kk = 0; i=0;
      do {
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%d", &j);
         i = (j >= 0) ? j : i+1;
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%lf %lf", &delta[i], &beta[i]);
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%lf %lf %lf", &d[i], &dmin[i], &dmax[i]);
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%c",&fitd[i]);
         if (fitd[i] == 'a') {
            k++;
            B[k] = d[i];
            Bmin[k] = dmin[i];
            Bmax[k] = dmax[i];
            pfit[k] = kk;
         }
         kk++;
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%lf %lf %lf", &dens[i], &densmin[i], &densmax[i]);
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%c",&fitdns[i]);
         if (fitdns[i] == 'a') {
            k++;
            B[k] = dens[i];
            Bmin[k] = densmin[i];
            Bmax[k] = densmax[i];
            pfit[k] = kk;
         }
         kk++;
      /*   while ((c = getc(fr)) != '$')
      ;
      fscanf(fr,"%lf %lf %lf", &rougth[i], &rougmin[i], &rougmax[i]);
      while ((c = getc(fr)) != '$')
      ;
      fscanf(fr,"%c",&fitr[i]);
      if (fitr[i] == 'a') {
      k++;
      B[k] = rougth[i];
      Bmin[k] = rougmin[i];
      Bmax[k] = rougmax[i];
      pfit[k] = kk;
      }
      k++ */
      } while (j >= 0);
   
      if (fitr[0] == 'a') {
         k++;
         B[k] = rougth[0];
         Bmin[k] = rougmin[0];
         Bmax[k] = rougmax[0];
         pfit[k] = kk;
      }
      kk++;
   
      pocet= i-1;     // Pocet vrstev
      NumPar = k;
      fclose(fr);
   
      h = 1;    //Gausovo rozdeleni
      delta[0] = beta[0] = 0;
   
      if (in == 'a') {
      //======================= Nacitani merenych dat =================
      
         fr = fopen(inpfile,"r");
         if (errno != 0) {printf("No such data file"); exit(1);}
      
         while ((c = getc(fr)) != '$')
            ;
         for (i=1;i<4;i++) {
            fscanf(fr,"%s\n",string); }
         i=0; intper_1 = 0;
         while (feof(fr) == 0) {
            i++;
            switch (ip) {
               case 'a': fscanf(fr,"%22e %22e %22lf \n", &X[i], &Y[i], &intper);
                  break;
               case 'n': fscanf(fr,"%22e %22e \n", &X[i], &Y[i]);
                  break;
            }
            switch (logfit) {
               case 'n': Vaha[i] = (Y[i] != 0) ? 1/Y[i] : 0;
                  if (ip == 'a') {
                     Vaha[i] *= (cas == 'c') ? intper-intper_1 :intper;
                     intper_1 = intper;
                  }
                  else  {
                     refl = Y[i]*iprim;
                     if (refl <= 1000) {Vaha[i] *= 2.5;}
                     if (refl <= 100) {Vaha[i] *= 2;}
                     if (refl <= 10) {Vaha[i] *= 2;}
                  }
                  break;
               case 'g': 
                  {Vaha[i] = (Y[i] != 0) ? 1 : 0;
                  //             refl = Y[i]*iprim;
                     Y[i] = (Y[i] != 0) ? log10(Y[i]) : Ymin;}
                  break;
            }
            if (X[i]<begf || X[i]>endf) {Vaha[i] *= 0;}  // vzorku se neuvazuje
         }
         NumDat =  i-1;      // Pocet fitovanych dat
         fclose(fr);
      
         sumavah=0;        //Vypocet sumy vah
         for (i=1; i<=NumDat; i++) sumavah+=Vaha[i];
      
         #ifdef __TURBOC__
      	grafi(0,X[NumDat],Ymin,Ymax);
      	#endif
         simulace(0,X[NumDat],Ymin,Ymax);
      	#ifdef __TURBOC__
         expdata(0,X[NumDat],Ymin,Ymax,X,Y);
         grafe();
      	#endif
      }
      else {
         #ifdef __TURBOC__
         grafi(Xmin,Xmax,Ymin,Ymax);
      	#endif
         simulace(Xmin,Xmax,Ymin,Ymax);
      	#ifdef __TURBOC__
         expdata(Xmin,Xmax,Ymin,Ymax,X,Y);
         grafe();
      	#endif
      }
   
   
      if (fit == 'a' && in == 'a') {
      
      // ============== fitovani pres potomka TMyMarq ==========
      
         TMyMarq *MyMarq;
         MyMarq = new TMyMarq ("trace.dat",1);  // inicializace fit. objektu
      // tez by to slo inicializovat  MyMarq = new TMyMarq ();
      
      // ted to nafituj
         MyMarq->Marq
            ( NumDat , X,Y,Vaha, NumPar/*pocet parametru*/, B,Bmin,Bmax, SumR, Eval, KolikPrint );
      // v B jsou odhadnute parametry
      
         UkazVysledky(MyMarq);
         delete MyMarq;  // zavola si destructor
      // uz jsem to nafitoval a zjistil vsechny stat. udaje
      
         cout << "Press any key...\n"; getch();
      
         #ifdef __TURBOC__
         grafi(0,X[NumDat],Ymin,Ymax);
      	#endif
         simulace(0,X[NumDat],Ymin,Ymax);
      	#ifdef __TURBOC__
         expdata(0,X[NumDat],Ymin,Ymax,X,Y);
         grafe();
      	#endif
      
      }
   
      if (fit == 'a' && in !='a') cout<<"Nenactena vstupni data";
   
   
   /*
   double sum, pom,res;
   int maxx, maxy;
   maxx = 80;
   maxy = 80;
   
   FILE *fp;
   fp = fopen("tr1pmp47.dat","w");
   for (k=0; k <=maxy; k+=1) {
   for (j=0; j <=maxx; j+=1) {
   dens[1] = j*(0.65-0.40)/maxx+0.40;
   //  rougth[0] = k*(3.6-3.2)/maxy+3.2;
   d[1] = k*(14.5-13.2)/maxy+13.2;
   
   for (i = 0;i <= pocet+1;i++) {
   n[i] = Complex(1-delta[i]*dens[i],-beta[i]*dens[i]);
   }
   sum = 0;
   for (i=1; i<=NumDat;i++) {
   pom = reflexe(lambda,h,X[i]-diver/2,pocet,n,d,rougth);
   pom += reflexe(lambda,h,X[i]+diver/2,pocet,n,d,rougth);
   // pom = reflexe(lambda,h,X[i],pocet,n,d,rougth);
   pom *= vzorek(X[i],bx,by,sx,sy)/2;
   pom += primar(X[i],bx,sx,dist,slit);
   res = pom+iback/iprim;
   //res = log10(res);
   sum +=Vaha[i]*pow(res-Y[i],2);
   }
   fprintf(fp,"%lf %lf %2.8lf \n",dens[1], d[1], sum);
   printf("	%lf %lf %2.8lf \r",dens[1], d[1], sum);
   //  fprintf(fp,"%lf %lf %lf \n",dens[2], rougth[0], sum);
   //  printf("%lf %lf %lf \r",dens[2], rougth[0], sum);
   printf("%d %d \r",j,k);
   }
   // fprintf(fp," \n");
   }
   fclose(fp);
   
   */
      free(fitr); free(fitd); free(fitdns); free(d); free(dmax);
      free(dmin); free(dens); free(densmax); free(densmin); free(delta); free(beta);
      free(rougth); free(rougmax); free(rougmin); free(n);
   
   
   }

