// pmcomplx.h
/* 
Petr Mikulik (mikulik@sci.muni.cz) - 1996
This header file eliminates the bordel in complex, Complex, Complx etc. 
of declarations, templates etc.

No need till gcc 2.6.3, complex problems are double since gcc 2.7.2
Hope this works for sometime now.
*/

#ifndef PMCOMPLX_H
#define PMCOMPLX_H

#ifdef __GNUC__
  #if (__GNUC__ <= 2 && __GNUC_MINOR__ <= 6)
      // until 2.6.3, Complex is the class
      #ifdef __EMX__   // Complx.h(hpfs) == Complex.h (ext2)
        #include <Complx.h>
      #else
        #include <Complex.h>
      #endif
  #else // above 2.7, complex is that template
    #include <complex.h>
    #define Complex double_complex
  #endif

// other compilers

#else
  #include <complex.h>
  // valid for at least Borland C++ (DOS, OS/2), DEC C++, Watcom
  #define Complex complex
#endif


/* // I have even noticed a C++ compiler without complex numbers (long time ago)!
#ifndef NO_SYSTEM_COMPLEX
  #include <complex.h>
//  #define complex Complex
#else
  #include "complex.h"
#endif
*/

#endif

// eof pmcomplx.h