#ifndef SPECFUN
#define SPECFUN


/*-----------------------------------------------------------------------
Gamma funkce - plna presnost pro x>1
------------------------------------------------------------------------*/
double gamma(double x);


/*----------------------------------------------------------------------------
BESSELK Modified Bessel functions of the second kind.
	K = BESSELK(ALPHA,X) computes modified Bessel functions of the
	second kind for real, non-negative order ALPHA and argument X.
	For ALPHA there is important restriction:
	ALPHA must be in the range 0 <= ALPHA(j) <= 1000.
     Examples:
	    besselk(3:9,[0:.2:9.8 10:.5:20],1) generates the entire
	    71-by-7 table on page 424 of Abramowitz and Stegun,
	    "Handbook of Mathematical Functions."
     See also: BESSELJ, BESSELY, BESSELI.
     Acknowledgement:
	This program is based on a Fortran program by W. J. Cody and
	L. Stoltz, Applied Mathematics Division, Argonne National
	Laboratory, dated May 30, 1989.  Their references include:

	    "On Temme's algorithm for the modified Bessel functions of the
	    third kind," Campbell, J. B., TOMS 6(4), Dec. 1980, pp. 581-586.

	    "A Fortran IV Subroutine for the modified Bessel functions of
	    the third kind of real order and real argument," Campbell, J. B.,
	    Report NRC/ERB-925, National Research Council, Canada.
----------------------------------------------------------------------------*/

double besselk(double alpha,double x);

#endif