/*---------------------------------------------------------------------------
|  Program  for fitting of scan of diffuse scattering                       |
|  on rough multilayer                                                      |
|  roughness - Gauss distribution                                           |
|  Numerical derivatives are used                                           |
|  posibility of periodical multilayer fitting               Verze 3.0      |
|  command \multi(number of stacks) { layer structure }                     |
|  posibility of compilation under GNU C (Emx)                              |
|                                                                           |
|         Mojmir  Meduna    27.8.2003                                       |
|                                                                           |
----------------------------------------------------------------------------*/

#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#ifdef __TURBOC__
  #include <alloc.h>
  #include<conio.h>
  #include<graphics.h>
#endif
#ifndef __TURBOC__
//  #define M_PI 3.14159265358979323846 
//  #define M_E 2.71828182845904523536
  #include<iostream.h>
#endif
//#include <dos.h>   // pouze kvuli funkci delay
#include<errno.h>

#include "pmcomplx.h"
#include "marqfitp.h"
#include "specfun.h"
#include "ansicpp.h"

   int POCET;      // POCET = pocet vrstev

   int PocetDat;   // NumDat;  // pocet "experimentalnich" dat
   const int KolikPrint = 1;  // 0 pro zadny, 1 kazdy, 2 kazdy druhy...
//   const delaytime=0; // chces-li vypocet trochu pozdrzet

// #define AnalDerivace    // define: bude se brat analyticka derivace
// #define AnalDerivace  // undefine: bude se brat numericka derivace

   Complex Im = Complex(0,1);  // Imag. jednotka

   typedef char * charvector;
   typedef int ** intmat;
   typedef Complex ** complmat;
   typedef double * dvector;
   typedef Complex * cvector;
   typedef Complex  matrix[2][2];
   typedef matrix  * matrvec;//[POCET+1];
   typedef Complex (* complvec)[2];

   char inpfile[255];   // Soubor s vstupnimi fitovanymi daty
   char soubor[255];    // Vystupni soubor s nafitovanou krivkou
   char string[15];
   char x2data;
   char in;             //Dotaz na vstup
   char out;            //Dotaz na vystup
   char logfit;         //Fitovat logaritmus
   char fit;            // Provest fitovani
   char sum;            //Provest zasumeni pri simulaci
   char backfit;        //Fitovat pozadi
   double  ips;            //integracni doba
   char jedn;           //Pouzite jednotky
   char disperiod;
   int tl1, tl2;
   double deld1, deld2;
   char bindsqrtr;    //Svazat drsnost odmocninovou zavislosti
   int lowr, higr;
   int RoughBj1;
   int RoughBj2;
   char bindr0N;      // svazat drsnost nejnizsiho rozhrani s drsnosti povrchu  
   char bindsqrtr2;    //Svazat drsnost odmocninovou zavislosti
   int lowr2, higr2;
   int RoughBj12;
   int RoughBj22;
   char bindr0N2;      // svazat drsnost nejnizsiho rozhrani s drsnosti povrchu  
   char bindsqrtr3;    //Svazat drsnost odmocninovou zavislosti
   int lowr3, higr3;
   int RoughBj13;
   int RoughBj23;
   char bindr0N3;      // svazat drsnost nejnizsiho rozhrani s drsnosti povrchu  
   char bindsqrtr4;    //Svazat drsnost odmocninovou zavislosti
   int lowr4, higr4;
   int RoughBj14;
   int RoughBj24;
   char bindr0N4;      // svazat drsnost nejnizsiho rozhrani s drsnosti povrchu  
   char fitpergam;         //Fitovat jednou periodu a pomer tloustek
   int perind, gammaind;
   char bindl1;    //Svazat drsnost odmocninovou zavislosti
   int lowl1, higl1;
   int LcorrBj11;
   int LcorrBj21;
   char bindl0N1;      // svazat drsnost nejnizsiho rozhrani s drsnosti povrchu  
   char bindl2;    //Svazat drsnost odmocninovou zavislosti
   int lowl2, higl2;
   int LcorrBj12;
   int LcorrBj22;
   char bindl0N2;      // svazat drsnost nejnizsiho rozhrani s drsnosti povrchu  
   char bindl3;    //Svazat drsnost odmocninovou zavislosti
   int lowl3, higl3;
   int LcorrBj13;
   int LcorrBj23;
   char bindl0N3;      // svazat drsnost nejnizsiho rozhrani s drsnosti povrchu  
   char bindl4;    //Svazat drsnost odmocninovou zavislosti
   int lowl4, higl4;
   int LcorrBj14;
   int LcorrBj24;
   char bindl0N4;      // svazat drsnost nejnizsiho rozhrani s drsnosti povrchu  
   int perbeg[10], perend[10], substd1,substd2; 
   int stack1;    // cislo hlavni fitovane ci narusene multivrstvy 
   int stackmax;    // maximalni poradi hlavni fitovane ci narusene multivrstvy 

   char dopad;          //uhel dopadu nebo omega
   char analyz;         //druh detektoru
   char cor;            //gausovka nebo bessel
   char semi;           //semikinematicky

   charvector fitr, fitl, fitd, fitdns;
   intmat mfit;
   intmat MEMI;
   complmat MEM;
   dvector d, dmin, dmax;                        // Tloustka vrstvy
   dvector dens, densmin, densmax;               // Relativni hustota
   dvector delta, beta, rougth, rougmin, rougmax;// Drsnost
   dvector l, lmin, lmax;                        // Korelacni delka
   double Lk;           //vertikalni korelace
   double chirepl;      //smer replikace
   dvector z;           //poloha rozhrani
   cvector n;           //index lomu
   char simmapy;           //simulace mapy
   double qxmin, qxmax, qxstep, qzmin, qzmax, qzstep;

   double lambda;      // lambda = vln. delka
   double begf, endf;  // Obor fitovani
   double begf1, endf1;  // Obor fitovani
   double h;           // fraktalovy koeficient
   int pocet;       // Skutecny pocet vrstev
   int NumDat;      // Skutecny pocet dat
   int NumPar;      // Pocet fitovanych parametru
   double iprim, iback, diver, divrad,  bx, bd, bx1, by, bx2, sx, sd, sx1, sy, sx2, cent, dist, slit;
   double sumavah;
   double lback, hback;
   double nsteps;

   double K;           //Vln. vektor ve vakuu
   double R;
   char drscanu;           //druh scanu
   char specdif;           // Spekularni, difuzni rozptyl ano-ne
   double offset, offsetd;
   double omega, omegad;
   double th, thd;
   double tha, thb;
   double apertura;

   const int NPAR=70;//4*(POCET+1); // Pocet parametru
   parfloat B[NPAR+1],Bmin[NPAR],Bmax[NPAR+1];  // npar+1 (pole je od jednicky)
   int pfit[NPAR+1];
   int I, J;
//   datafloat X[PocetDat+1], Y[PocetDat+1], Vaha[PocetDat+1];
   datafloat *X, *Y, *Vaha;
   datafloat SumR;
   int Eval; // boolean

// Definice objektu s funkci, jez se bude fitovat, se provede pomoci
//  naslednika TMarq takhle:

   class
   TMyMarq: virtual public TMarq {
   public:
      TMyMarq (const char* aTraceFile, int AShowErrors):
      TMarq(aTraceFile,AShowErrors) { 
      }; // konstruktor
      TMyMarq (): TMarq("tracefit.dat",1) { 
      } ; // implicitni konstruktor
   protected:
      virtual datafloat FitFun
      ( datafloat X, parfloat *B, int& Fres );
      #ifdef AnalDerivace
      virtual void DoJac ( int I, datafloat *X, parfloat *B,
   	   parfloat *D, int& dres );
      #endif
      virtual void Residue ( datafloat& Res, int& Suc,
                        datafloat *X, datafloat *Y, datafloat *Vaha, parfloat *B );
       // kdybych neumel spocitat derivaci, tak bych tuhle proceduru
      // sem nepridal a pouzivala by se numericka derivace
   };

   void UkazVysledky ( TMarq *M ) {
      cout <<"\nResults:\n";
      cout<<"Residue="<<SumR<<"      Eval="<<Eval
         #ifdef ElaTime
         <<"    Time: "<<M->GetElapsedTime(1)
         #endif
         ; cout<<"  Number of iterations: "<<M->citer<<'\n';
      for (I=1; I<=NumPar; I++)
         cout<<"Fitted parameter n. "<<I<<" is: "<<B[I]
            <<" +- "<<sqrt( M->GetSigma(I) )<<'\n';
      cout<<"Backround = "<<iback;
      if (backfit=='y' && logfit != 'g') cout<<" +- "<<sqrt(M->GetDisperze()/sumavah)*iprim<<"\n";
      else cout<<"\n";
      // cout<<"Press any key for Korel. koef. \n"; getch();
      cout<<"Correlation coefficients:\n";
      for (I=1; I<=NumPar; I++) {
         cout<<I;
         for (J=1; J<=I; J++) cout<<"  "<<M->GetKorelKoef(I,J);
         cout <<'\n'; };
      cout <<"Dispersion per unit weight = "<<M->GetDisperze()<<'\n';
   };


   void ShowMemory() {
   #ifdef __TURBOC__
   cout<<"\nThe difference between the highest allocated block in the far\n";
   cout<<"heap and the top of the far heap is: "<<farcoreleft()<<" bytes\n";
   cout<<"The difference between the highest allocated block and\n";
   cout<<"the top of the heap is "<<coreleft()<<" B\n\n";
   #endif
   }

   void nas (matrix a, matrix b, matrix& c)    // Nasobeni matic
   {
      int i, j, k;
   
      for (i = 0; i<2; i++)  {
         for (j = 0; j<2; j++) {
            c[i][j] = 0;
            for (k = 0; k<2; k++)
               c[i][j] =c[i][j] + a[i][k] * b[k][j];
         }
      }
   }


   double cuttozero(double x)             
   {
      return((x>=0)?x:0);
   }


   double GAMMA(double x)   // Gamma funkce
   {
      double  stp = 2.50662827465,
         half= 0.5,
         one = 1.0,
         fpf = 5.5;
      double  cof[6] = {76.18009173,-86.50532033,24.01409822,
         -1.231739516,0.120858003e-2,-0.536382e-5};
      int i,j;
      double xx, tmp, ser, gam;
   
      i = 0;
      if (x < 1) {x += 1; i = 1;
      }
      xx = x-one;  tmp = xx+fpf;  tmp = (xx+half)*log(tmp)-tmp;
      ser = one;
      for (j =0;j < 6;j++) {
         xx += one;  ser += cof[j]/xx;
      }
      gam = exp(tmp+log(stp*ser));
   
      if (i == 1) gam = gam/(x-1);
   
      return(gam);
   }


   Complex chi(double rougthness, Complex q) // Charakteristicka funkce
   {                                       // obecnych rozdeleni
   
      double H=1;
      Complex W, x;
   
      x = rougthness*q;
      if (H == 1 || H == 0.5) {
         if (H == 1)
            W = exp(-0.5*pow(x,2));    // Gausovo rozdeleni
         else
            W = 1/(2+pow(x,2));        // Exponencialni rozdeleni
      }
      else {
         int i, num = 100;
         double krok = 0.1;  // Pro H=1/5 lepe krok 0.01 a pro H=1/10 radeji 0.0001
         Complex s;          // Pro 1>H>1/2 dostatecna presnost
         double A, B;        // A*exp(-B*x^(2*H))
         B = GAMMA(3/(2*H))/GAMMA(1/(2*H));   // Vypocet koeficientu pro rozdeleni
         A = H*sqrt(B)/GAMMA(1/(2*H));
         B = pow(B,H);
      
         s = cos(0)*exp(-B*pow(0,2*H));
         for (i =1;i<num;i++) {
            s += 4*cos((2*i-1)*krok*x)*exp(-B*pow((2*i-1)*krok,2*H))+2*cos(2*i*krok*x)*exp(-B*pow(2*i*krok,2*H));
         }
         s += 4*cos((2*i-1)*krok*x)*exp(-B*pow((2*i-1)*krok,2*H))+cos(2*i*krok*x)*exp(-B*pow(2*i*krok,2*H));
         s *= 2*A*krok/3;
         W = s;
      }
   
      return(W);
   }


   float erf(float x) {
   
      float t,z,ans;
   
      z=fabs(x);
      t=1.0/(1.0+0.5*z);
      ans=t*exp(-z*z-1.26551223+
               t*(1.00002368+t*(0.37409196+
                               t*(0.09678418+t*(-0.18628806+
                                               t*(0.27886807+t*(-1.13520398+
                                                               t*(1.48851587+t*(-0.82215223+
                                                                               t*0.17087277)))))))));
      return x >= 0.0 ? 1.0-ans : ans-1.0;
   }

   int eldensityprof(int NMAX, dvector d, dvector dens, dvector delta, dvector rougth) {
   
      int i;
      float *z;
      if ((z = (float *) malloc(sizeof(float)*(NMAX+1))) == NULL) {printf("Allocation error \n"); exit(1);}
   
      z[0]=0;
      for(i=1;i<=NMAX;i++) {
         z[i]=z[i-1]+d[i];
      }
   
      float step=(z[NMAX]+3*rougth[0]+3*rougth[NMAX])/20000;
      float x,s;
   
      FILE *fw;
      fw = fopen("elprofdens.dat","w");
   
      for(x=-3*rougth[0];x<=z[NMAX]+3*rougth[NMAX];x+=step) {
         s=0;
         for(i=0;i<=NMAX;i++) {
            s+=(delta[i+1]*dens[i+1]-delta[i]*dens[i])/delta[NMAX+1]*(erf((x-z[i])/rougth[i])/2+0.5);
         }
         fprintf(fw,"%f %f \n",x,s);
      }
      fclose(fw);
      free(z);
   
      return i;
   }


   double C(int i,int j,double x)  //Korelacni funkce Gauss
   {
      double c;
   
      int m= (i>j) ? i : j;
      double opr = (i!=j) ? (Lk!=0) ? exp(-fabs(z[i]-z[j])/Lk) : 0 : 1;
   
      c=rougth[m]*rougth[m]*exp(-pow(fabs(x)/l[m],2*h))*opr;
      return(c);
   }


   double Cb(int i,int j,double x)  //Korelacni funkce Bessel
   {
      double c;
   
      int m= (i>j) ? i : j;
      double opr = (i!=j) ? (Lk!=0) ? exp(-fabs(z[i]-z[j])/Lk) : 0 : 1;
   
      c=rougth[m]*rougth[m]*opr;
      if (x!=0) {
         c*=(pow(fabs(x)/l[m],h));
         c*=besselk(h,fabs(x)/l[m]);
         c*=h/gamma(h+1)/pow(2,h-1);
      }
   
      return(c);
   }



//-------Vypocty spektralnich hustot-------------------------------

   Complex QQ(int i,int j,double Qx,Complex qz1,Complex qz2)   //Simpsnova metoda
   {
   
      unsigned long k;
      long double eps;
      double powtwo, obor, x1, x2;
      Complex moc, polsir, ab, s, t1, t2;
      int n;
   
      eps=0.000001;  //pro h=0.5 dQ<~1%  eps-nasobek k maximu
          //pro h=1   dQ<~0.01%
   
      if (i!=j && Lk==0) {t1=0; ab=obor=1;}
      else {
         ab = qz1*conj(qz2);
         moc = rougth[i]*rougth[j]*ab;
      //polsir=l*pow(log(moc/log((exp(moc)+1)/2)),0.5/h);
         obor=l[i]*pow(logl(real(moc)/logl((exp(real(moc))-1)*eps+1)),0.5/h);
      
         x1=obor/2; x2=obor;
         s = exp(ab*C(i,j,0))-1;
         s+=4*cos(Qx*x1)*(exp(ab*C(i,j,x1))-1);
         s+=cos(Qx*x2)*(exp(ab*C(i,j,x2))-1);
         t1=s;
         t2=t1;
         n=1;
      
         do{
            n++;
            powtwo=pow(2,n-2);
            for (k=1;k<=powtwo;k++) {
               x1=obor/powtwo/2*(2*k-1);
               x2=x1/2;
               s-=2*cos(Qx*x1)*(exp(ab*C(i,j,x1))-1);
               s+=4*cos(Qx*x2)*(exp(ab*C(i,j,x2))-1);
            }
            for (k=(long unsigned int)powtwo+1;k<=2*(long unsigned int)powtwo;k++) {
               x1=obor/powtwo/4*(2*k-1);
               s+=4*cos(Qx*x1)*(exp(ab*C(i,j,x1))-1);
            }
            t2=t1;
            t1=s/powtwo/2;
         } while (abs(t2/t1-1)>1e-5 || n<3);
      }
   
      s=t1*obor/3/ab;
      s*=exp(-(rougth[i]*rougth[i]*qz1*qz1+rougth[j]*rougth[j]*conj(qz2*qz2))/2);
      s*=exp(Im*Qx*tan(chirepl)*(z[i]-z[j]));
   
      return(s);
   }


/*
Complex QQX(int i,int j,double Qx,Complex qz1, Complex qz2)   //Simpsnova metoda po substituci
{   //stejne jako QQX1 ale obecne pro C(i,j,x)

unsigned long k;
double powtwo, eps, obor, x1, x2, x11, x22;
Complex moc, polsir, ab, s, t1, t2;
int n;

eps=0.0000001;

ab = qz1*conj(qz2);
moc = rougth[i]*rougth[j]*ab;
//polsir=log(moc/log((exp(moc)+1)/2));
obor=logl(real(moc)/logl((exp(real(moc))-1)*eps+1));

x1=l[i]*pow(obor/2,1/(2*h));
x2=l[i]*pow(obor,1/(2*h));
x11=l[i]*pow(obor/2,1/(2*h)-1);
x22=l[i]*pow(obor,1/(2*h)-1);
s = 0; //exp(abs(qz*qz)*C(0))-1;
s=4*cos(Qx*x1)*(exp(ab*C(i,j,x1))-1)*x11;
s+=cos(Qx*x2)*(exp(ab*C(i,j,x2))-1)*x22;
t1=s;
t2=t1;
n=1;

do{
  n++;
  powtwo=pow(2,n-2);
  for (k=1;k<=powtwo;k++) {
    x1=l[i]*pow(obor/powtwo/2*(2*k-1),1/(2*h));
    x2=l[i]*pow(obor/powtwo/4*(2*k-1),1/(2*h));
    x11=l[i]*pow(obor/powtwo/2*(2*k-1),1/(2*h)-1);
    x22=l[i]*pow(obor/powtwo/4*(2*k-1),1/(2*h)-1);
    s-=2*cos(Qx*x1)*(exp(ab*C(i,j,x1))-1)*x11;
    s+=4*cos(Qx*x2)*(exp(ab*C(i,j,x2))-1)*x22;
  }
  for (k=powtwo+1;k<=2*powtwo;k++) {
    x1=l[i]*pow(obor/powtwo/4*(2*k-1),1/(2*h));
    x11=l[i]*pow(obor/powtwo/4*(2*k-1),1/(2*h)-1);
    s+=4*cos(Qx*x1)*(exp(ab*C(i,j,x1))-1)*x11;
  }
  t2=t1;
  t1=s/powtwo/2;
} while (abs(t2/t1-1)>0.01 || n<3);

s=t1*obor/3/ab/(2*h);
s*=exp(-(rougth[i]*rougth[i]*qz1*qz1+rougth[j]*rougth[j]*conj(qz2*qz2))/2);

return(s);
}
*/


   Complex QQX1(int i,int j,double Qx,Complex qz1, Complex qz2)   //Simpsnova metoda po substituci
   {                                   //funkce sig^2*exp(-x/l^2h)
   
      unsigned long k;
      long double a, b, polsir, powtwo, eps, obor, x1, x2, x11, x22;
      Complex moc, ab, s, t1, t2;
      int n;
   
      int m= (i>j) ? i : j;
      double opr = (i!=j) ? (Lk!=0) ? exp(-fabs(z[i]-z[j])/Lk) : 0 : 1;
   
      eps=pow(10,-6+14*(h-0.5)); //pro h=0.5 dQ<~5%
   
      if (i!=j && Lk==0) {t1=0; ab=obor=1;}
      else {
         ab = qz1*conj(qz2);
         moc = rougth[m]*rougth[m]*ab*opr;
      //polsir=log(moc/log((exp(moc)+1)/2));
         obor=logl(real(moc)/logl((exp(real(moc))-1)*eps+1));
      
         x1=l[m]*pow(obor/2,1/(2*h));
         x2=l[m]*pow(obor,1/(2*h));
         s = 0; //exp(abs(qz*qz)*C(0))-1;
         s=4*cos(Qx*x1)*(exp(moc*expl(-obor/2))-1)*2*x1/obor;
         s+=cos(Qx*x2)*(exp(moc*expl(-obor))-1)*x2/obor;
         t1=s;
         t2=t1;
         n=1;
      
         do{
            n++;
            powtwo=pow(2,n-2);
            b=obor/powtwo/2;
            for (k=1;k<=powtwo;k++) {
               a=b*(2*k-1);
               x1=l[m]*pow(a,1/(2*h));
               x2=l[m]*pow(a/2,1/(2*h));
               s-=2*cos(Qx*x1)*(exp(moc*expl(-a))-1)*x1/a;
               s+=4*cos(Qx*x2)*(exp(moc*expl(-a/2))-1)*2*x2/a;
            }
            for (k=(long unsigned int)powtwo+1;k<=2*(long unsigned int)powtwo;k++) {
               a=b*(k-0.5);
               x1=l[m]*pow(a,1/(2*h));
               s+=4*cos(Qx*x1)*(exp(moc*expl(-a))-1)*x1/a;
            }
            t2=t1;
            t1=s/powtwo/2;
         } while (abs(t2/t1-1)>0.01 || n<3);
      }
   
      s=t1*obor/3/ab/(2*h);
      s*=exp(-(rougth[i]*rougth[i]*qz1*qz1+rougth[j]*rougth[j]*conj(qz2*qz2))/2);
      s*=exp(Im*Qx*tan(chirepl)*(z[i]-z[j]));
   
      return(s);
   }


/*
double QQ1(double Qx,Complex qz)  //Integrace s cos
{

unsigned long i, k;
long double moc, polsir, eps, obor;
long double s, t1, t2, dx, hh, AA, BB, CC, s0, s2, c0, c2, i1, i2, i3;
long double x0, x1, x2, y0, y1, y2, A, o,p,q;
int n;
double sig=10;

eps=0.0001;

moc = sig*sig*abs(qz*qz);
polsir=l[i]*powl(logl(moc/logl((exp(moc)+1)/2)),0.5/h);
obor=l[i]*powl(logl(moc/logl((exp(moc)-1)*eps+1)),0.5/h);

dx=polsir/1000;

hh=dx/2;

A=hh*Qx;

s=0;
y2 = exp(abs(qz*qz)*C(1,1,0))-1;
i=0;
//do {
//i++;
for (i=1;i<=obor/dx;i++) {
  x0=dx*(i-1); x1=dx*(i-0.5); x2=dx*i;
  y0=exp(abs(qz*qz)*C(1,1,x0))-1;//y2;
  y1=exp(abs(qz*qz)*C(1,1,x1))-1;
  y2=exp(abs(qz*qz)*C(1,1,x2))-1;

//cout<<y0<<y1<<y2<<"\n";

  s0=sin(Qx*x0);  s2=sin(Qx*x2);
  c0=cos(Qx*x0);  c2=cos(Qx*x2);  //??
  i1=(A*A-2)*(s2-s0)+2*A*(c2+c0);
  i2=Qx*(c2-c0)+Qx*A*(s2+s0); //??
  i3=Qx*Qx*(s2-s0);               //??
  AA=(y0+y2-2*y1)/2;
  BB=(y2-y0)/2*hh;
  CC=y1*hh*hh;
  s+=i1*AA+i2*BB*i3*CC;
//  t2=t1;
//  t1=s;
  }

//while (fabs(t2/t1-1)>0.001);

s/=abs(qz*qz)*Qx*Qx*Qx*hh*hh*hh;
s*=exp(-sig*sig*real(qz*qz));

return(s);
}

*/

   Complex QQ2(int i,int j,double Qx,Complex qz1, Complex qz2) //Analyticky h=1
   {
   
      int n;
      long double f;
      double t1, t2;
      Complex s, ab;
   
      int m= (i>j) ? i : j;
      double opr = (i!=j) ? (Lk!=0) ? exp(-fabs(z[i]-z[j])/Lk) : 0 : 1;
   
      if (opr!=0) {
         ab = qz1*conj(qz2);
         t1=0;
      
         s=0;
         n=0;
         f=1;
         do {
            n++;
            f*=n;
            if (n<120) s+=pow(ab*rougth[m]*rougth[m]*opr,n)/sqrt(n)*exp(-pow(Qx*l[m]/2,2)/n)/f;
            else s+=pow(ab*rougth[m]*rougth[m]*opr*M_E/n,n)/sqrt(2*M_PI*n)/(1+1/12/n+1/288/n/n)/sqrt(n)*exp(-pow(Qx*l[m]/2,2)/n);
            t2 = t1;
            t1 = abs(s);
            if (t2 == 0) t2=1;
         } while(fabs(t1/t2-1) > 1e-15);
      
         s*=l[m]*sqrt(M_PI);
         s*=exp(-(rougth[i]*rougth[i]*qz1*qz1+rougth[j]*rougth[j]*conj(qz2*qz2))/2)/ab;
         s*=exp(Im*Qx*tan(chirepl)*(z[i]-z[j]));
      }
      else s=0;
   
      return(s);
   }



   Complex QQ3(int i,int j,double Qx,Complex qz1, Complex qz2) //Analyticky h=1/2
   {
   
      unsigned long n;
      double t1, t2;
      Complex s; 
      Complex ab;
      long double f;
   
      int m= (i>j) ? i : j;
      double opr = (i!=j) ? (Lk!=0) ? exp(-fabs(z[i]-z[j])/Lk) : 0 : 1;
   
      if (opr!=0) {
         ab = qz1*conj(qz2);
         t1=0;
      
         s=0;
         n=0;
         f=1;
         do {
            n++;
            f*=n;
            if (n<120) s+=pow(ab*rougth[m]*rougth[m]*opr,n)*n/(n*n+pow(Qx*l[m],2))/f;
            else s+=pow(ab*rougth[m]*rougth[m]*opr*M_E/n,n)/sqrt(2*M_PI*n)/(1+1/12/n+1/288/n/n)*n/(n*n+pow(Qx*l[m],2));
            t2 = t1;
            t1 = abs(s);
            if (t2 == 0) t2=1;
         } while(fabs(t1/t2-1) > 1e-15);
         s*=2*l[m];
         s*=exp(-(rougth[i]*rougth[i]*qz1*qz1+rougth[j]*rougth[j]*conj(qz2*qz2))/2)/ab;
         s*=exp(Im*Qx*tan(chirepl)*(z[i]-z[j]));
      }
      else s=0;
   
      return(s);
   }


   Complex QQ4(int i,int j,double Qx,Complex qz1,Complex qz2)   
   // substituce sin(Qx*x)=t, vypocteni dilcich integralua secteni rady pres periody 
   {
   
      unsigned long k, kk;
      long double eps;
      double powtwo, oborl, oboru, x0, x1, x2;
      Complex moc, polsir, ab, s, sint, t1, t2, tint1, tint2;
      int n;
   
      eps=0.000001;  //pro h=0.5 dQ<~1%  eps-nasobek k maximu
          //pro h=1   dQ<~0.01%
   
      if (fabs(Qx)<2e-6) Qx=2e-6;
      if (i!=j && Lk==0) {t1=0; ab=oboru=oborl=1;}
      else {
      
         ab = qz1*conj(qz2);
         moc = rougth[i]*rougth[j]*ab;
      //polsir=l*pow(log(moc/log((exp(moc)+1)/2)),0.5/h);
      
      //Prvni integral od 0 do1 
         oboru=1;
         oborl=0;
         x0=oborl; x1=oborl+(oboru-oborl)/2; x2=oboru;
         s = exp(ab*C(i,j,asin(x0)/Qx))-1;
         s+=4*cos(Qx*x1)*(exp(ab*C(i,j,asin(x1)/Qx))-1);
         s+=cos(Qx*x2)*(exp(ab*C(i,j,asin(x2)/Qx))-1);
         t1=s;  
         t2=t1;
         n=1;
      
         do{
            n++;
            powtwo=pow(2,n-2);
            for (k=1;k<=powtwo;k++) {
               x1=oborl+(oboru-oborl)/powtwo/2*(2*k-1);
               x2=oborl+(oboru-oborl)/powtwo/4*(2*k-1);
               s-=2*cos(Qx*x1)*(exp(ab*C(i,j,asin(x1)/Qx))-1);
               s+=4*cos(Qx*x2)*(exp(ab*C(i,j,asin(x2)/Qx))-1);
            }
            for (k=(long unsigned int)powtwo+1;k<=2*(long unsigned int)powtwo;k++) {
               x2=oborl+(oboru-oborl)/powtwo/4*(2*k-1);
               s+=4*cos(Qx*x2)*(exp(ab*C(i,j,asin(x2)/Qx))-1);
            }
            t2=t1;
            t1=s/powtwo/2; 
         } while (abs(t2/t1-1)>1e-5 || n<3);
         sint=t1*(oboru-oborl)/3; //? s=t1*(oboru-oborl)/6;
      
      //Rada ostatnich integralu od -1 do 1 
         oboru=1;
         oborl=-1;
         kk=0;
         do{
            kk++; //Zde zacina lichy integral
            x0=oborl; x1=oborl+(oboru-oborl)/2; x2=oboru;
            s = exp(ab*C(i,j,(asin(x0)+M_PI*kk)/Qx))-1;
            s+=4*cos(Qx*x1)*(exp(ab*C(i,j,(asin(x1)+M_PI*kk)/Qx))-1);
            s+=cos(Qx*x2)*(exp(ab*C(i,j,(asin(x2)+M_PI*kk)/Qx))-1);
            t1=s;  
            t2=t1;
            n=1;
         
            do{
               n++;
               powtwo=pow(2,n-2);
               for (k=1;k<=powtwo;k++) {
                  x1=oborl+(oboru-oborl)/powtwo/2*(2*k-1);
                  x2=oborl+(oboru-oborl)/powtwo/4*(2*k-1);
                  s-=2*cos(Qx*x1)*(exp(ab*C(i,j,(asin(x1)+M_PI*kk)/Qx))-1);
                  s+=4*cos(Qx*x2)*(exp(ab*C(i,j,(asin(x2)+M_PI*kk)/Qx))-1);
               }
               for (k=(long unsigned int)powtwo+1;k<=2*(long unsigned int)powtwo;k++) {
                  x2=oborl+(oboru-oborl)/powtwo/4*(2*k-1);
                  s+=4*cos(Qx*x2)*(exp(ab*C(i,j,(asin(x2)+M_PI*kk)/Qx))-1);
               }
               t2=t1;
               t1=s/powtwo/2; 
            } while (abs(t2/t1-1)>1e-5 || n<3);
            sint+=pow(-1,kk)*t1*(oboru-oborl)/3; //? s=t1*(oboru-oborl)/6;
         
            kk++; //Zde zacina sudy integral
            x0=oborl; x1=oborl+(oboru-oborl)/2; x2=oboru;
            s = exp(ab*C(i,j,(asin(x0)+M_PI*kk)/Qx))-1;
            s+=4*cos(Qx*x1)*(exp(ab*C(i,j,(asin(x1)+M_PI*kk)/Qx))-1);
            s+=cos(Qx*x2)*(exp(ab*C(i,j,(asin(x2)+M_PI*kk)/Qx))-1);
            t1=s;  
            t2=t1;
            n=1;
         
            do{
               n++;
               powtwo=pow(2,n-2);
               for (k=1;k<=powtwo;k++) {
                  x1=oborl+(oboru-oborl)/powtwo/2*(2*k-1);
                  x2=oborl+(oboru-oborl)/powtwo/4*(2*k-1);
                  s-=2*cos(Qx*x1)*(exp(ab*C(i,j,(asin(x1)+M_PI*kk)/Qx))-1);
                  s+=4*cos(Qx*x2)*(exp(ab*C(i,j,(asin(x2)+M_PI*kk)/Qx))-1);
               }
               for (k=(long unsigned int)powtwo+1;k<=2*(long unsigned int)powtwo;k++) {
                  x2=oborl+(oboru-oborl)/powtwo/4*(2*k-1);
                  s+=4*cos(Qx*x2)*(exp(ab*C(i,j,(asin(x2)+M_PI*kk)/Qx))-1);
               }
               t2=t1;
               t1=s/powtwo/2; 
            } while (abs(t2/t1-1)>1e-5 || n<3);
            sint+=pow(-1,kk)*t1*(oboru-oborl)/3; //? s=t1*(oboru-oborl)/6;
         
            tint2=tint1;
            tint1=sint;
         }while (abs(tint2/tint1-1)>1e-5 || kk<3);
      
      }
      sint*=1/Qx;
      sint*=exp(-(rougth[i]*rougth[i]*qz1*qz1+rougth[j]*rougth[j]*conj(qz2*qz2))/2)/ab;
      sint*=exp(Im*Qx*tan(chirepl)*(z[i]-z[j]));
   
      return(sint);
   }


   Complex QQK(int i,int j,double Qx,Complex qz1,Complex qz2)   //Simpsnova metoda
   {  //besselovy fce
   
      unsigned long k;
      long double eps;
      double powtwo, obor, x1, x2;
      Complex moc, polsir, ab, s, t1, t2;
      int n;
   
   //eps=0.000001;  //pro h=0.5 dQ<~1%  eps-nasobek k maximu
          //pro h=1   dQ<~0.01%
   
      if (i!=j && Lk==0) {t1=0; ab=obor=1;}
      else {
         ab = qz1*conj(qz2);
         moc = rougth[i]*rougth[j]*ab;
      //polsir=l*pow(log(moc/log((exp(moc)+1)/2)),0.5/h);
      //   obor=l[i]*pow(logl(real(moc)/logl((exp(real(moc))-1)*eps+1)),0.5/h);
         obor=l[i]*15;   //pro th<2deg rougth<20 rel. chyba odrezu~1E-5
      
         x1=obor/2; x2=obor;
         s = exp(ab*Cb(i,j,0))-1;
         s+=4*cos(Qx*x1)*(exp(ab*Cb(i,j,x1))-1);
         s+=cos(Qx*x2)*(exp(ab*Cb(i,j,x2))-1);
         t1=s;
         t2=t1;
         n=1;
      
         do{
            n++;
            powtwo=pow(2,n-2);
            for (k=1;k<=powtwo;k++) {
               x1=obor/powtwo/2*(2*k-1);
               x2=x1/2;
               s-=2*cos(Qx*x1)*(exp(ab*Cb(i,j,x1))-1);
               s+=4*cos(Qx*x2)*(exp(ab*Cb(i,j,x2))-1);
            }
            for (k=(long unsigned int)powtwo+1;k<=2*(long unsigned int)powtwo;k++) {
               x1=obor/powtwo/4*(2*k-1);
               s+=4*cos(Qx*x1)*(exp(ab*Cb(i,j,x1))-1);
            }
            t2=t1;
            t1=s/powtwo/2;
         } while (abs(t2/t1-1)>1e-5 || n<3);
      }
   
   
      s=t1*obor/3;
      s/=ab;
      s*=exp(-(rougth[i]*rougth[i]*qz1*qz1+rougth[j]*rougth[j]*conj(qz2*qz2))/2);
      s*=exp(Im*Qx*tan(chirepl)*(z[i]-z[j]));
   
      return(s);
   }



   Complex QQK1(int i,int j,double Qx, Complex qz1, Complex qz2)  //analiticky Bessel funkce
   {
      double c, c0;
      Complex s;
   
      int m= (i>j) ? i : j;
      double opr = (i!=j) ? (Lk!=0) ? exp(-fabs(z[i]-z[j])/Lk) : 0 : 1;
   
      if (opr!=0) {
         c0 = 2*sqrt(M_PI)*rougth[m]*rougth[m]*l[m]*gamma(h+0.5)/gamma(h+1)*h;
         c = c0*pow(1+pow(Qx*l[m],2),-0.5-h)*opr;
      
         s = c*exp(-(rougth[i]*rougth[i]*qz1*qz1+rougth[j]*rougth[j]*conj(qz2*qz2))/2);
         s*=exp(Im*Qx*tan(chirepl)*(z[i]-z[j]));
      }
      else s=0;
   
      return(s);
   }


   Complex QQW(int i,int j,double Qx, Complex qz1, Complex qz2)  //libovolny rozptylovy faktor
   {
      Complex s, ab;
      int m= (i>j) ? i : j;
      double opr = (i!=j) ? (Lk!=0) ? exp(-fabs(z[i]-z[j])/Lk) : 0 : 1;
   
      if (opr!=0) {
         ab = qz1*conj(qz2);
         s=1e-15; //Zde patri s=integrovany rozptylovy faktor ... W(Qx,qz1,qz2)
         s*=opr/ab;
         s*=exp(Im*Qx*tan(chirepl)*(z[i]-z[j]));
      }
      else s=0;
   
      return(s);
   }


   Complex QQ2A(int i,int j,int k,double Qx,Complex qz1, Complex qz2) 
   {
      int m= (i>j) ? i : j;
      if (MEMI[m][k]==0)
      {
         MEM[m][k]=QQ2(m,m,Qx,qz1,qz2);
         MEMI[m][k]=1;
      }
      double opr = (i!=j) ? (Lk!=0) ? exp(-fabs(z[i]-z[j])/Lk) : 0 : 1;
   
      return(MEM[m][k]*opr);
   }




   Complex QQ3A(int i,int j,int k,double Qx,Complex qz1, Complex qz2) 
   
   {
      int m= (i>j) ? i : j;
      if (MEMI[m][k]==0)
      {
         MEM[m][k]=QQ3(m,m,Qx,qz1,qz2);
         MEMI[m][k]=1;
      }
      double opr = (i!=j) ? (Lk!=0) ? exp(-fabs(z[i]-z[j])/Lk) : 0 : 1;
   
      return(MEM[m][k]*opr);
   }



   Complex QQA(int i,int j,int k,double Qx,Complex qz1, Complex qz2) 
   
   {
      int m= (i>j) ? i : j;
      if (MEMI[m][k]==0)
      {
         MEM[m][k]=QQ(m,m,Qx,qz1,qz2);
         MEMI[m][k]=1;
      }
      double opr = (i!=j) ? (Lk!=0) ? exp(-fabs(z[i]-z[j])/Lk) : 0 : 1;
   
      return(MEM[m][k]*opr);
   }



   Complex QQ4A(int i,int j,int k,double Qx,Complex qz1, Complex qz2) 
   
   {
      int m= (i>j) ? i : j;
      if (MEMI[m][k]==0)
      {
         MEM[m][k]=QQ4(m,m,Qx,qz1,qz2);
         MEMI[m][k]=1;
      }
      double opr = (i!=j) ? (Lk!=0) ? exp(-fabs(z[i]-z[j])/Lk) : 0 : 1;
   
      return(MEM[m][k]*opr);
   }

   int NULLMEM(complmat A,intmat B)
   {
      int m, k;
      for(m=0;m<=pocet;m++) {
         for(k=0;k<=16;k++) {
            A[m][k]=0;
            B[m][k]=0;
         }
      }
      return(1);
   }



   double JID(double thinc, double theta) //Idealni signal detektoru
   {
      Complex Jid;
      cvector kz1, kz2;
      cvector fip, fim; /* fazove cleny  exp(+-Im*kz*d)  */
      cvector r, t; /* Fresnelovy koeficienty i-teho rozhrani */
      complvec E1, E2;
      Complex XX, T0, s, p;
      int i, j;
      double Qx;
   
      if ((kz1 = (cvector) malloc(sizeof(Complex)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((kz2 = (cvector) malloc(sizeof(Complex)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((fip = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((fim = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((r = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((t = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((E1 = (complvec) malloc(2*sizeof(Complex)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((E2 = (complvec) malloc(2*sizeof(Complex)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
   
      if (thinc==0) thinc+=1E-6;
      if (2*theta==thinc) theta-=1E-6;
      if (thinc==theta) thinc+=1E-6;
   
      kz1[0] = -K*sin(thinc);
      kz2[0] = K*sin(2*theta-thinc);
      Qx=2*K*sin(theta)*sin(thinc-theta);
      //cout<<0<<" "<<kz1[0]<<" "<<kz2[0]<<"\n";
   
      if (semi!='s') {
         for(i=1;i<=pocet+1;i++) {
            kz1[i] = -(sqrt(kz1[0]*kz1[0]-K*K*(1-n[i]*n[i])));
            kz2[i] = sqrt(kz2[0]*kz2[0]-K*K*(1-n[i]*n[i]));
         //cout<<i<<" "<<kz1[i]<<" "<<kz2[i]<<"\n";
         }
      }
   
      if (semi=='s') {
         for(i=1;i<=pocet+1;i++) {
            kz1[i] = -(sqrt(kz1[0]*kz1[0]-K*K*(1-n[pocet+1]*n[pocet+1])));
            kz2[i] = sqrt(kz2[0]*kz2[0]-K*K*(1-n[pocet+1]*n[pocet+1]));
         //cout<<i<<" "<<kz1[i]<<" "<<kz2[i]<<"\n";
         }
      }
   
   //---Vypocet intenzit E1----------------------------
      if (semi!='s') {
         for (i = 0; i < pocet; i++) {
            r[i] = (kz1[i]-kz1[i+1])/(kz1[i]+kz1[i+1]);
            t[i] = 1+r[i];
            fip[i+1] = exp(-Im*kz1[i+1]*d[i+1]);
            fim[i+1] = 1/fip[i+1];
         }
         r[i] = (kz1[i]-kz1[i+1])/(kz1[i]+kz1[i+1]);
         t[i] = 1+r[i];
      
      //Vypocet amplitudy pro vlnu E=EA*exp(Im*K*x); K=KR-Im*KI kde KI>0
      
         E1[pocet+1][0] = exp(Im*kz1[pocet+1]*z[pocet]);  E1[pocet+1][1] = 0;
         for (i = pocet; i>0; i--) {
            E1[i][0] = (E1[i+1][0]+E1[i+1][1]*r[i])*fip[i]/t[i];
            E1[i][1] = (E1[i+1][0]*r[i]+E1[i+1][1])*fim[i]/t[i];
            //cout<<i<<" "<<E1[i][0]<<" "<<E1[i][1]<<"\n";
         }
         E1[0][0] = (E1[1][0]+E1[1][1]*r[0])/t[0];
         E1[0][1] = (E1[1][0]*r[0]+E1[1][1])/t[0];
         //cout<<i<<" "<<E1[i][0]<<" "<<E1[i][1]<<"\n";
      }
   
      if (semi=='s') {
         E1[pocet+1][0] = exp(Im*kz1[pocet+1]*z[pocet]);  E1[pocet+1][1] = 0;
         for (i = pocet; i>0; i--) {
            E1[i][0] = E1[i+1][0]*exp(-Im*kz1[i]*d[i]);
            E1[i][1] = 0;
         }
         E1[0][0] = E1[1][0]*(kz1[0]+kz1[pocet+1])/(2*kz1[0]);
         E1[0][1] = E1[1][0]*(kz1[0]-kz1[pocet+1])/(2*kz1[0]);
      }
   
   // XX= E1[0][1]/E1[0][0];
   // T0 = 1/E1[0][0];
   
   //---Vypocet intenzit E2------------------------------
      if (semi!='s') {
         for (i = 0; i < pocet; i++) {
            r[i] = (kz2[i]-kz2[i+1])/(kz2[i]+kz2[i+1]);
            t[i] = 1+r[i];
            fip[i+1] = exp(+Im*kz2[i+1]*d[i+1]);
            fim[i+1] = 1/fip[i+1];
         }
         r[i] = (kz2[i]-kz2[i+1])/(kz2[i]+kz2[i+1]);
         t[i] = 1+r[i];
      
         E2[pocet+1][0] = exp(-Im*kz2[pocet+1]*z[pocet]);  E2[pocet+1][1] = 0;
         for (i = pocet; i>0; i--) {
            E2[i][0] = (E2[i+1][0]+E2[i+1][1]*r[i])*fip[i]/t[i];
            E2[i][1] = (E2[i+1][0]*r[i]+E2[i+1][1])*fim[i]/t[i];
         }
         E2[0][0] = (E2[1][0]+E2[1][1]*r[0])/t[0];
         E2[0][1] = (E2[1][0]*r[0]+E2[1][1])/t[0];
      }
   
      if (semi=='s') {
         E2[pocet+1][0] = exp(-Im*kz2[pocet+1]*z[pocet]);  E2[pocet+1][1] = 0;
         for (i = pocet; i>0; i--) {
            E2[i][0] = E2[i+1][0]*exp(+Im*kz2[i]*d[i]);
            E2[i][1] = 0;
         }
         E2[0][0] = E2[1][0]*(kz2[0]+kz2[pocet+1])/(2*kz2[0]);
         E2[0][1] = E2[1][0]*(kz2[0]-kz2[pocet+1])/(2*kz2[0]);
      }
   
   // XX= E2[0][1]/E2[0][0];
   // T0 = 1/E2[0][0];
   
      free(fip); free(fim); free(r); free(t);
   
      int mingcorr=0;
      if (mingcorr==1) {
      
         if (semi!='s') {
            if (cor == 'g') {
               if (h==1) {
                  s=0;
                  for(i=0;i<=pocet;i++) {
                     for(j=0;j<=pocet;j++) {
                     //  j=i;
                        p=0;
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ2(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQ2(i,j,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQ2(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQ2(i,j,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQ2(i,j,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQ2(i,j,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQ2(i,j,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQ2(i,j,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ2(i,j,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQ2(i,j,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQ2(i,j,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQ2(i,j,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQ2(i,j,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQ2(i,j,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQ2(i,j,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQ2(i,j,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                        s+=p;
                     }
                  }
               }
            
            
               if (h==0.5) {
                  s=0;
                  for(i=0;i<=pocet;i++) {
                     for(j=0;j<=pocet;j++) {
                     //    j=i;
                        p=0;
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ3(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQ3(i,j,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQ3(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQ3(i,j,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQ3(i,j,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQ3(i,j,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQ3(i,j,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQ3(i,j,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ3(i,j,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQ3(i,j,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQ3(i,j,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQ3(i,j,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQ3(i,j,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQ3(i,j,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQ3(i,j,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQ3(i,j,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                        s+=p;
                     }
                  }
               }
            
            
               if (h>0.5 && h<1) {
                  s=0;
                  for(i=0;i<=pocet;i++) {
                     for(j=0;j<=pocet;j++) {
                     //  j=i;
                        p=0;
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQ(i,j,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQ(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQ(i,j,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQ(i,j,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQ(i,j,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQ(i,j,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQ(i,j,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ(i,j,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQ(i,j,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQ(i,j,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQ(i,j,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQ(i,j,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQ(i,j,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQ(i,j,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQ(i,j,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                        s+=p;
                     }
                  }
               }
            
               if (h>=0.4999 && h<0.5) {
                  s=0;
                  for(i=0;i<=pocet;i++) {
                     for(j=0;j<=pocet;j++) {
                     //  j=i;
                        p=0;
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQX1(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQX1(i,j,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQX1(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQX1(i,j,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQX1(i,j,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQX1(i,j,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQX1(i,j,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQX1(i,j,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQX1(i,j,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQX1(i,j,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQX1(i,j,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQX1(i,j,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQX1(i,j,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQX1(i,j,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQX1(i,j,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQX1(i,j,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                        s+=p;
                     }
                  }
               }
               if (h<0.4999) {
                  s=0;
                  for(i=0;i<=pocet;i++) {
                     for(j=0;j<=pocet;j++) {
                     //  j=i;
                        p=0;
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ4(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQ4(i,j,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQ4(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQ4(i,j,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQ4(i,j,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQ4(i,j,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQ4(i,j,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQ4(i,j,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ4(i,j,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQ4(i,j,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQ4(i,j,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQ4(i,j,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQ4(i,j,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQ4(i,j,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQ4(i,j,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQ4(i,j,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                        s+=p;
                     }
                  }
               }
            }
            else {
               s=0;
               for(i=0;i<=pocet;i++) {
                  for(j=0;j<=pocet;j++) {
                  //  j=i;
                     p=0;
                     p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQK(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                     p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQK(i,j,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                     p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQK(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                     p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQK(i,j,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                     p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQK(i,j,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                     p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQK(i,j,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                     p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQK(i,j,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                     p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQK(i,j,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                     p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQK(i,j,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                     p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQK(i,j,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                     p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQK(i,j,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                     p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQK(i,j,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                     p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQK(i,j,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                     p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQK(i,j,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                     p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQK(i,j,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                     p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQK(i,j,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                     p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                     s+=p;
                  }
               }
            }
         }
         else {
            if (cor == 'g') {
               if (h==1) {
                  s=0;
                  for(i=0;i<=pocet;i++) {
                     for(j=0;j<=pocet;j++) {
                     //  j=i;
                        p=0;
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ2(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                        s+=p;
                     }
                  }
               }
            
            
               if (h==0.5) {
                  s=0;
                  for(i=0;i<=pocet;i++) {
                     for(j=0;j<=pocet;j++) {
                     //    j=i;
                        p=0;
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ3(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                        s+=p;
                     }
                  }
               }
            
            
               if (h>0.5 && h<1) {
                  s=0;
                  for(i=0;i<=pocet;i++) {
                     for(j=0;j<=pocet;j++) {
                     //  j=i;
                        p=0;
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                        s+=p;
                     }
                  }
               }
            
               if (h>=0.4999 && h<0.5) {
                  s=0;
                  for(i=0;i<=pocet;i++) {
                     for(j=0;j<=pocet;j++) {
                     //  j=i;
                        p=0;
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQX1(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                        s+=p;
                     }
                  }
               }
            
               if (h<0.4999) {
                  s=0;
                  for(i=0;i<=pocet;i++) {
                     for(j=0;j<=pocet;j++) {
                     //  j=i;
                        p=0;
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ4(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                        s+=p;
                     }
                  }
               }
            
            }
            else {
               s=0;
               for(i=0;i<=pocet;i++) {
                  for(j=0;j<=pocet;j++) {
                  //  j=i;
                     p=0;
                     p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQK(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                     p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                     s+=p;
                  }
               }
            }
         }
      }
      else {
      
         if (semi!='s') {
            if (cor == 'g') {
               if (h==1) {
                  s=0;
                  NULLMEM(MEM,MEMI);
                  for(i=0;i<=pocet;i++) {
                     for(j=0;j<=pocet;j++) {
                     //  j=i;
                        p=0;
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ2A(i,j,1,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQ2A(i,j,2,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQ2A(i,j,3,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQ2A(i,j,4,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQ2A(i,j,5,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQ2A(i,j,6,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQ2A(i,j,7,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQ2A(i,j,8,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ2A(i,j,9,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQ2A(i,j,10,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQ2A(i,j,11,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQ2A(i,j,12,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQ2A(i,j,13,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQ2A(i,j,14,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQ2A(i,j,15,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQ2A(i,j,16,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                        s+=p;
                     }
                  }
               }
            
            
               if (h==0.5) {
                  s=0;
                  NULLMEM(MEM,MEMI);
                  for(i=0;i<=pocet;i++) {
                     for(j=0;j<=pocet;j++) {
                     //    j=i;
                        p=0;
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ3A(i,j,1,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQ3A(i,j,2,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQ3A(i,j,3,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQ3A(i,j,4,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQ3A(i,j,5,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQ3A(i,j,6,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQ3A(i,j,7,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQ3A(i,j,8,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ3A(i,j,9,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQ3A(i,j,10,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQ3A(i,j,11,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQ3A(i,j,12,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQ3A(i,j,13,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQ3A(i,j,14,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQ3A(i,j,15,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQ3A(i,j,16,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                        s+=p;
                     }
                  }
               }
            
            
               if (h>0.5 && h<1) {
                  s=0;
                  NULLMEM(MEM,MEMI);
                  for(i=0;i<=pocet;i++) {
                     for(j=0;j<=pocet;j++) {
                     //  j=i;
                        p=0;
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQA(i,j,1,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQA(i,j,2,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQA(i,j,3,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQA(i,j,4,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQA(i,j,5,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQA(i,j,6,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQA(i,j,7,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQA(i,j,8,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQA(i,j,9,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQA(i,j,10,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQA(i,j,11,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQA(i,j,12,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQA(i,j,13,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQA(i,j,14,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQA(i,j,15,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQA(i,j,16,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                        s+=p;
                     }
                  }
               }
            
               if (h<0.5) {
                  s=0;
                  NULLMEM(MEM,MEMI);
                  for(i=0;i<=pocet;i++) {
                     for(j=0;j<=pocet;j++) {
                     //  j=i;
                        p=0;
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ4A(i,j,1,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQ4A(i,j,2,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQ4A(i,j,3,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQ4A(i,j,4,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQ4A(i,j,5,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQ4A(i,j,6,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQ4A(i,j,7,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQ4A(i,j,8,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ4A(i,j,9,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQ4A(i,j,10,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQ4A(i,j,11,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQ4A(i,j,12,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQ4A(i,j,13,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQ4A(i,j,14,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQ4A(i,j,15,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                        p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQ4A(i,j,16,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                        p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                        s+=p;
                     }
                  }
               }
            }
            else {
               cout<<"Bessel corr. func. not implemented for this approximation. \n";
            /*
               s=0;
               for(i=0;i<=pocet;i++) {
                  for(j=0;j<=pocet;j++) {
                  //  j=i;
                     p=0;
                     p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQK(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                     p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQK(i,j,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                     p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQK(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                     p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQK(i,j,Qx,kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                     p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQK(i,j,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                     p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQK(i,j,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]-kz1[j+1]);
                     p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQK(i,j,Qx,-kz2[i+1]-kz1[i+1],kz2[j+1]+kz1[j+1]);
                     p+=E1[i+1][0]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQK(i,j,Qx,-kz2[i+1]-kz1[i+1],-kz2[j+1]+kz1[j+1]);
                     p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQK(i,j,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                     p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][1])*QQK(i,j,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                     p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][0])*QQK(i,j,Qx,kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                     p+=E1[i+1][1]*E2[i+1][0]*conj(E1[j+1][1]*E2[j+1][1])*QQK(i,j,Qx,kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                     p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][0])*QQK(i,j,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]-kz1[j+1]);
                     p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][0]*E2[j+1][1])*QQK(i,j,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]-kz1[j+1]);
                     p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][0])*QQK(i,j,Qx,-kz2[i+1]+kz1[i+1],kz2[j+1]+kz1[j+1]);
                     p+=E1[i+1][1]*E2[i+1][1]*conj(E1[j+1][1]*E2[j+1][1])*QQK(i,j,Qx,-kz2[i+1]+kz1[i+1],-kz2[j+1]+kz1[j+1]);
                     p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                     s+=p;
                  }
               }
            	*/
            }
         }
         else {
            if (cor == 'g') {
               if (h==1) {
                  s=0;
                  NULLMEM(MEM,MEMI);
                  for(i=0;i<=pocet;i++) {
                     for(j=0;j<=pocet;j++) {
                     //  j=i;
                        p=0;
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ2A(i,j,1,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                        s+=p;
                     }
                  }
               }
            
            
               if (h==0.5) {
                  s=0;
                  NULLMEM(MEM,MEMI);
                  for(i=0;i<=pocet;i++) {
                     for(j=0;j<=pocet;j++) {
                     //    j=i;
                        p=0;
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ3A(i,j,1,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                        s+=p;
                     }
                  }
               }
            
            
               if (h>0.5 && h<1) {
                  s=0;
                  NULLMEM(MEM,MEMI);
                  for(i=0;i<=pocet;i++) {
                     for(j=0;j<=pocet;j++) {
                     //  j=i;
                        p=0;
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQA(i,j,1,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                        s+=p;
                     }
                  }
               }
            
               if (h<0.5) {
                  s=0;
                  NULLMEM(MEM,MEMI);
                  for(i=0;i<=pocet;i++) {
                     for(j=0;j<=pocet;j++) {
                     //  j=i;
                        p=0;
                        p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQ4A(i,j,1,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                        p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                        s+=p;
                     }
                  }
               }
            
            }
            else {
               s=0;
               for(i=0;i<=pocet;i++) {
                  for(j=0;j<=pocet;j++) {
                  //  j=i;
                     p=0;
                     p+=E1[i+1][0]*E2[i+1][0]*conj(E1[j+1][0]*E2[j+1][0])*QQK(i,j,Qx,kz2[i+1]-kz1[i+1],kz2[j+1]-kz1[j+1]);
                     p*=(n[i]*n[i]-n[i+1]*n[i+1])*conj(n[j]*n[j]-n[j+1]*n[j+1]);
                     s+=p;
                  }
               }
            }
         }
      
      }
   
   
      Jid = s*pow(K,3)/(8*M_PI)/pow(E1[0][0]*E2[0][0],2);
   
      free(kz1); free(kz2); free(E1); free(E2);
   
      return(abs(Jid));
   }


   double F(double x)   // Tvarova funkce detektoru
   {
      double p;     //x,tha,thb - v rad
      x= 2*fabs(x);
      p = (x<=tha) ? 1 : (x<=thb)?(x-thb)/(tha-thb) :0; //negative x values are not important
      return(p);
   }


   double G(double x)   // Tvarova funkce analyzatoru detektoru
   {
      double p;     //x,tha,thb - v rad
      x=2*x;
      p=thb*exp(-x*x/tha);
   
      return(p);
   }

   double Rcoh(double theta)  //Koherentni reflektivita
   {
   
      cvector kz1;
      cvector fip, fim; /* fazove cleny  exp(+-Im*kz*d)  */
      cvector r, t; /* Fresnelovy koeficienty i-teho rozhrani */
      matrvec Ri;    // reflex. matice s charakter fcemi
      complvec E1;
      Complex XX, s, p;
      int i;
   
      if ((kz1 = (cvector) malloc(sizeof(Complex)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((fip = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((fim = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((r = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((t = (cvector) malloc(sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((Ri = (matrvec) malloc(4*sizeof(Complex)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((E1 = (complvec) malloc(2*sizeof(Complex)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
   
      if (theta==0) theta+=1E-6;
   
      kz1[0] = K*sin(theta);
   //kz1[0] = Qz/2;
      for(i=1;i<=pocet+1;i++) {
         kz1[i] = sqrt(kz1[0]*kz1[0]-K*K*(1-n[i]*n[i]));
      }
   
      for (i = 0; i < pocet; i++) {
         r[i] = (kz1[i]-kz1[i+1])/(kz1[i]+kz1[i+1]);
         t[i] = 1+r[i];
         fip[i+1] = exp(+Im*kz1[i+1]*d[i+1]);
         fim[i+1] =1/fip[i+1];
         Ri[i][0][0] = chi(rougth[i],kz1[i]-kz1[i+1]);
         Ri[i][0][1] = r[i]*chi(rougth[i],kz1[i+1]+kz1[i]);
         Ri[i][1][0] = r[i]*chi(rougth[i],-kz1[i+1]-kz1[i]);
         Ri[i][1][1] = chi(rougth[i],kz1[i+1]-kz1[i]);
      }
      r[i] = (kz1[i]-kz1[i+1])/(kz1[i]+kz1[i+1]);
      t[i] = 1+r[i];
      Ri[i][0][0] = chi(rougth[i],kz1[i]-kz1[i+1]);
      Ri[i][0][1] = r[i]*chi(rougth[i],kz1[i+1]+kz1[i]);
      Ri[i][1][0] = r[i]*chi(rougth[i],-kz1[i+1]-kz1[i]);
      Ri[i][1][1] = chi(rougth[i],kz1[i+1]-kz1[i]);
   
      free(kz1);
   
      E1[pocet+1][0] = 1;  E1[pocet+1][1] = 0;
      for (i = pocet; i>0; i--) {
         E1[i][0] = (E1[i+1][0]*Ri[i][0][0]+E1[i+1][1]*Ri[i][0][1])*fip[i]/t[i];
         E1[i][1] = (E1[i+1][0]*Ri[i][1][0]+E1[i+1][1]*Ri[i][1][1])*fim[i]/t[i];
      }
      E1[0][0] = (E1[1][0]*Ri[0][0][0]+E1[1][1]*Ri[0][0][1])/t[0];
      E1[0][1] = (E1[1][0]*Ri[0][1][0]+E1[1][1]*Ri[0][1][1])/t[0];
      free(fip); free(fim); free(r); free(t); free(Ri);
   
      XX= E1[0][1]/E1[0][0];
      free(E1);
   
      return(abs(XX*XX));
   
   }


	// Oprava na primar zasahujici do vzorku pri malych uhlech
   double primar(double thri, double thre, double bx1, double sx1, double bx2, double sx2, double dist, double slit)
   {                      // Predp. ze sterbina je sirsi nez primar
      double pdet, sxx1, pom, pr;   // justace do 1/2 primaru
      double thradi, thrade;
      //thradi = (jedn == 'v') ? thri*M_PI/648000 : thri*M_PI/180;   // prevod z vterin na rad
      //thrade = (jedn == 'v') ? thre*M_PI/648000 : thre*M_PI/180;   // prevod z vterin na rad
      pdet = dist*sin(thre+thri)-slit/2+cent;
      sxx1 = sx1*sin(thri)+cent*(1-cos(thri));
      if ((sxx1 < (bx1+cent)) && (pdet < (bx1+cent))) {
         pom = (sxx1 > pdet) ? sxx1 : pdet;
         pr = (bx1 + cent - pom)/(bx1+bx2); 
      }
      else
         pr = 0;
      return(pr);
   }

   datafloat JJ(datafloat thi,datafloat theta)
   {            //thi, theta v radianech
   
      double Ji, plocha, a1, b1, c1, a2, b2, c2;
   
      if (thi<=1E-5) thi=1E-5;
      if (2*theta<=1E-5) theta=5E-6;
      if (2*theta-thi<=1E-5) theta+=1E-6;
      if (thi==theta) thi+=1E-6;
   
      //cent=(bx2-bx1)/2;
      a1 = (bx1+cent*cos(thi))/(bx1+bx2)/sin(thi);
      b1 = sx1/(bx1+bx2);
      c1 = slit/(bx1+bx2)/sin(2*theta-thi);
      a2 = (bx2-cent*cos(thi))/(bx1+bx2)/sin(thi);
      b2 = sx2/(bx1+bx2);
      c2 = slit/(bx1+bx2)/sin(2*theta-thi); //assumption that the analyzer spot is always in the sample center
   
      // a = 1/sin(thi);
      // b = sx/bx;
      // c = slit/bx/sin(2*theta-thi);                                     // not correct
      //plocha = (a < b) ? a : b;
      //if (analyz == 'a') plocha = (plocha < c) ? plocha : c;
      // plocha =  min(1/sin(thi),sx/bx)* C2/C1 - C1 -known correct curve, C2 - curve with general geom. fact.
   
      if (analyz != 'y') plocha = ((a1 < b1) ? a1 : b1) + ((a2 < b2) ? a2 : b2);
   
      if (analyz == 'y') plocha = (((a1 < c1) || (b1 < c1)) ? (a1 < b1) ? a1 : b1 : c1) + (((a2 < c2) || (b2 < c2)) ? (a2 < b2) ? a2 : b2 : c2);
   
       //plocha = plocha*((thi<0.844*M_PI/180) ? (1.18*thi*180/M_PI) : 1);
       //plocha = plocha*((thi<0.844*M_PI/180) ? (0.93*thi*180/M_PI+0.3*thi*thi*180/M_PI*180/M_PI) : 1);
       //plocha = plocha*((thi<0.844*M_PI/180) ? (1.12*thi*180/M_PI-0.7*thi*thi*180/M_PI*180/M_PI+0.92*thi*thi*thi*180/M_PI*180/M_PI*180/M_PI) : 1);
   
   
      if (divrad !=0) {
         if (specdif=='c' || specdif=='d'){
            Ji = JID(thi-divrad/2,theta);
            Ji += JID(thi+divrad/2,theta);
            Ji *= apertura/2;
         }
         else Ji = 1e-18;
         if (specdif=='c') Ji += (analyz == 'y') ? G(thi-theta)*(Rcoh(thi-divrad/2)+Rcoh(thi+divrad/2))/2*sin(thi) : F(thi-theta)*(Rcoh(thi-divrad/2)+Rcoh(thi+divrad/2))/2*sin(thi);
         if (specdif=='s') Ji = (analyz == 'y') ? G(thi-theta)*(Rcoh(thi-divrad/2)+Rcoh(thi+divrad/2))/2*sin(thi) : F(thi-theta)*(Rcoh(thi-divrad/2)+Rcoh(thi+divrad/2))/2*sin(thi);
         Ji *= plocha;
      //  Ji *= (sin(thi) < bx1/sx1) ? sx1/bx1*sin(thi) : 1;
      //  Ji *= (analyz == 'y' && thi < 2*theta*bx1/(slit+bx1)) ? slit/bx1*sin(thi)/sin(2*theta-thi) : 1;
         Ji += primar(thi,theta,bx1,sx1,bx2,sx2,dist,slit);
         Ji += iback/iprim;
      }
      else {
         if (specdif=='c' || specdif=='d'){
            Ji = JID(thi,theta);
            Ji *= apertura;
         }
         else Ji = 1e-18;
         if (specdif=='c') Ji += (analyz == 'y') ? G(thi-theta)*Rcoh(thi)*sin(thi) : F(thi-theta)*Rcoh(thi)*sin(thi);
         if (specdif=='s') Ji = (analyz == 'y') ? G(thi-theta)*Rcoh(thi)*sin(thi) : F(thi-theta)*Rcoh(thi)*sin(thi);
         Ji *= plocha;
      //  Ji *= (sin(thi) < bx1/sx1) ? sx1/bx1*sin(thi) : 1;
      //  Ji *= (analyz == 'y' && thi < 2*theta*bx1/(slit+bx1)) ? slit/bx1*sin(thi)/sin(2*theta-thi) : 1;
         Ji += primar(thi,theta,bx1,sx1,bx2,sx2,dist,slit);
         Ji += iback/iprim;
      }
   
      return(Ji);
   
   }



   datafloat TMyMarq::FitFun( datafloat X, parfloat *B, int& Fres ) {
   
      int i, j, k, c, f;
      datafloat res;
   
      // B[i] obsahuje stale tloustky s presnou periodou
      if (disperiod=='y') {    //Odstraneni opravy tloustek na posun v periode      
         for (j = 0; j<=(perend[stack1]-perbeg[stack1]);j++) {  // <- cykl pres vrstvy v jedne periode
            for (i = tl1-j; i >= tl2-j+(perend[stack1]-perbeg[stack1]);i-=(perend[stack1]-perbeg[stack1]+1)) d[i]=d[tl1-j]-(tl1-i-j)/2*(((int)(j/2)==j/2)? deld1:deld2);
         }
      }
   
      if (fitpergam=='y') {
         double x1, x2;
         x1=B[perind];
         x2=B[gammaind];
         B[perind]=x1*x2;        //Fitovani periody
         B[gammaind]=x1*(1-x2);//-di
         for (i=perbeg[stack1];i<=substd1-1;i++) B[gammaind]-=d[i];
         for (i=substd1+1;i<=substd2-1;i++) B[gammaind]-=d[i];
         for (i=substd2+1;i<=perend[stack1];i++) B[gammaind]-=d[i];
         //cout<<x1<<" "<<x2<<" "<<B[perind]<<" "<<B[gammaind]<<"\n";
      //cout<<B[1]<<B[2];
      }
   
      Fres=1;
   #ifndef __GNUC__
      delay(delaytime); // jinak by se to spocitalo prilis rychle, kdyby nebyl vystup na obrazovku
   #endif
      for (i = 1;i <= NumPar;i++) {
         c = (int)pfit[i]/4;
         f = pfit[i]-4*c;
         j=0;
         while (mfit[c][j] != 0) {//cyklus dokud se parametr jeste nachazi v nasledujici periode; pro lib. pocet multivrstev
            k = mfit[c][j];
            switch (f) {
               case 3:      d[k] = B[i]; 
                  break;
               case 2:   dens[k] = B[i]; 
                  break;
               case 1:    l[k-1] = B[i]; 
                  break;
               case 0: rougth[k-1] = B[i]; 
                  break;
            }
            j++;
         }
      }
   
   // B[i] obsahuje stale tloustky s presnou periodou
      if (fitpergam=='y') {
         double b1=B[perind]+B[gammaind]; //+di substd1-B[perind] substd2-B[gammaind]
         for (i=perbeg[stack1];i<=substd1-1;i++) b1+=d[i];
         for (i=substd1+1;i<=substd2-1;i++) b1+=d[i];
         for (i=substd2+1;i<=perend[stack1];i++) b1+=d[i];
         double b2=B[perind]/b1;
         //cout<<B[perind]<<" "<<B[gammaind]<<" "<<b1<<" "<<b2<<" "<<"\n";
         B[perind]=b1;
         B[gammaind]=b2;
      }
   
      // B[i] obsahuje stale tloustky s presnou periodou
      if (disperiod=='y') {    //Odstraneni opravy tloustek na posun v periode      
         for (j = 0; j<=(perend[stack1]-perbeg[stack1]);j++) {  // <- cykl pres vrstvy v jedne periode
            for (i = tl1-j; i >= tl2-j+(perend[stack1]-perbeg[stack1]);i-=(perend[stack1]-perbeg[stack1]+1)) d[i]=d[tl1-j]+(tl1-i-j)/2*(((int)(j/2)==j/2)? deld1:deld2);
         }
      }
   
   //if (disperiod =='y') {    //Znovu pridani opravy tloustek na posun v periode  
   //for (i = tl1; i >= tl2+1 ;i-=2) d[i]=d[tl1]+(tl1-i-(tl1-tl2+1)/2)/2*deld1;
   //for (i = tl1-1; i >= tl2 ;i-=2) d[i]=d[tl1-1]+(tl1-i-1-(tl1-tl2+1)/2)/2*deld2;
   //}
   
      if (bindsqrtr=='y') {
         if (bindr0N=='y') rougth[RoughBj1]=rougth[RoughBj2];
         double DDj=0;
         for (i = pocet;i >= (RoughBj1+1) ;i--) DDj=DDj+d[i];
         double DD0=DDj;
         for (i = (RoughBj1);i >= (RoughBj2+1) ;i--) DD0=DD0+d[i]; //polohy fitovanych drsnosti
         double DD=0;
         for (i = pocet;i >= (lowr+1) ;i--) DD=DD+d[i];
         for (i = lowr;i >= (higr+1) ;i--) {
         //         DD=pocet-i; DD0=pocet;           //svazani drsnosti
            rougth[i]=sqrt(cuttozero(rougth[RoughBj1]*rougth[RoughBj1]+(rougth[RoughBj2]*rougth[RoughBj2]-rougth[RoughBj1]*rougth[RoughBj1])*(DD-DDj)/(DD0-DDj)));
            DD=DD+d[i];
         }
         rougth[higr]=sqrt(cuttozero(rougth[RoughBj1]*rougth[RoughBj1]+(rougth[RoughBj2]*rougth[RoughBj2]-rougth[RoughBj1]*rougth[RoughBj1])*(DD-DDj)/(DD0-DDj)));
      }
   
      if (bindsqrtr2=='y') {
         if (bindr0N2=='y') rougth[RoughBj12]=rougth[RoughBj22];
         double DDj=0;
         for (i = pocet;i >= (RoughBj12+1) ;i--) DDj=DDj+d[i];
         double DD0=DDj;
         for (i = (RoughBj12);i >= (RoughBj22+1) ;i--) DD0=DD0+d[i]; //polohy fitovanych drsnosti
         double DD=0;
         for (i = pocet;i >= (lowr2+1) ;i--) DD=DD+d[i];
         for (i = lowr2;i >= (higr2+1) ;i--) {
         //         DD=pocet-i; DD0=pocet;           //svazani drsnosti 1
            rougth[i]=sqrt(cuttozero(rougth[RoughBj12]*rougth[RoughBj12]+(rougth[RoughBj22]*rougth[RoughBj22]-rougth[RoughBj12]*rougth[RoughBj12])*(DD-DDj)/(DD0-DDj)));
            DD=DD+d[i];
         }
         rougth[higr2]=sqrt(cuttozero(rougth[RoughBj12]*rougth[RoughBj12]+(rougth[RoughBj22]*rougth[RoughBj22]-rougth[RoughBj12]*rougth[RoughBj12])*(DD-DDj)/(DD0-DDj)));
      }
   
      if (bindsqrtr3=='y') {
         if (bindr0N3=='y') rougth[RoughBj13]=rougth[RoughBj23];
         double DDj=0;
         for (i = pocet;i >= (RoughBj13+1) ;i--) DDj=DDj+d[i];
         double DD0=DDj;
         for (i = (RoughBj13);i >= (RoughBj23+1) ;i--) DD0=DD0+d[i]; //polohy fitovanych drsnosti
         double DD=0;
         for (i = pocet;i >= (lowr3+1) ;i--) DD=DD+d[i];
         for (i = lowr3;i >= (higr3+1) ;i-=2) {
         //         DD=pocet-i; DD0=pocet;           //svazani drsnosti 1
            rougth[i]=sqrt(cuttozero(rougth[RoughBj13]*rougth[RoughBj13]+(rougth[RoughBj23]*rougth[RoughBj23]-rougth[RoughBj13]*rougth[RoughBj13])*(DD-DDj)/(DD0-DDj)));
            DD=DD+d[i]+d[i-1];
         }
         rougth[higr3]=sqrt(cuttozero(rougth[RoughBj13]*rougth[RoughBj13]+(rougth[RoughBj23]*rougth[RoughBj23]-rougth[RoughBj13]*rougth[RoughBj13])*(DD-DDj)/(DD0-DDj)));
      }
   
      if (bindsqrtr4=='y') {
         if (bindr0N4=='y') rougth[RoughBj14]=rougth[RoughBj24];
         double DDj=0;
         for (i = pocet;i >= (RoughBj14+1) ;i--) DDj=DDj+d[i];
         double DD0=DDj;
         for (i = (RoughBj14);i >= (RoughBj24+1) ;i--) DD0=DD0+d[i]; //polohy fitovanych drsnosti
         double DD=0;
         for (i = pocet;i >= (lowr4+1) ;i--) DD=DD+d[i];
         for (i = lowr4;i >= (higr4+1) ;i-=2) {
         //         DD=pocet-i; DD0=pocet;           //svazani drsnosti 1
            rougth[i]=sqrt(cuttozero(rougth[RoughBj14]*rougth[RoughBj14]+(rougth[RoughBj24]*rougth[RoughBj24]-rougth[RoughBj14]*rougth[RoughBj14])*(DD-DDj)/(DD0-DDj)));
            DD=DD+d[i]+d[i-1];
         }
         rougth[higr4]=sqrt(cuttozero(rougth[RoughBj14]*rougth[RoughBj14]+(rougth[RoughBj24]*rougth[RoughBj24]-rougth[RoughBj14]*rougth[RoughBj14])*(DD-DDj)/(DD0-DDj)));
      }
   
      if (bindl1=='y') {
         if (bindl0N1=='y') l[LcorrBj11]=l[LcorrBj21];
         double DL;
         DL=(rougth[LcorrBj11]!=rougth[LcorrBj21]) ? l[LcorrBj21]/2*(1+sqrt(1+4*pow(l[LcorrBj11]/l[LcorrBj21],2)*(l[LcorrBj21]/l[LcorrBj11]-1)/(rougth[LcorrBj21]/rougth[LcorrBj11]-1))) : 0;
         for (i = lowl1;i >= higl1 ;i--) {
            l[i]=(rougth[LcorrBj11]*rougth[LcorrBj11]*l[LcorrBj11]*l[LcorrBj11]+(rougth[i]*rougth[i]-rougth[LcorrBj11]*rougth[LcorrBj11])*DL*DL)/(rougth[LcorrBj11]*rougth[LcorrBj11]*l[LcorrBj11]+(rougth[i]*rougth[i]-rougth[LcorrBj11]*rougth[LcorrBj11])*DL);
         }
      }
   
      if (bindl2=='y') {
         if (bindl0N2=='y') l[LcorrBj12]=l[LcorrBj22];
         double DL;
         DL=(rougth[LcorrBj12]!=rougth[LcorrBj22]) ? l[LcorrBj22]/2*(1+sqrt(1+4*pow(l[LcorrBj12]/l[LcorrBj22],2)*(l[LcorrBj22]/l[LcorrBj12]-1)/(rougth[LcorrBj22]/rougth[LcorrBj12]-1))) : 0;
         for (i = lowl1;i >= higl1 ;i--) {
            l[i]=(rougth[LcorrBj12]*rougth[LcorrBj12]*l[LcorrBj12]*l[LcorrBj12]+(rougth[i]*rougth[i]-rougth[LcorrBj12]*rougth[LcorrBj12])*DL*DL)/(rougth[LcorrBj12]*rougth[LcorrBj12]*l[LcorrBj12]+(rougth[i]*rougth[i]-rougth[LcorrBj12]*rougth[LcorrBj12])*DL);
         }
      }
   
      if (bindl3=='y') {
         if (bindl0N3=='y') l[LcorrBj13]=l[LcorrBj23];
         double DL;
         DL=(rougth[LcorrBj13]!=rougth[LcorrBj23]) ? l[LcorrBj23]/2*(1+sqrt(1+4*pow(l[LcorrBj13]/l[LcorrBj23],2)*(l[LcorrBj23]/l[LcorrBj13]-1)/(rougth[LcorrBj23]/rougth[LcorrBj13]-1))) : 0;
         for (i = lowl1;i >= higl1 ;i-=2) {
            l[i]=(rougth[LcorrBj13]*rougth[LcorrBj13]*l[LcorrBj13]*l[LcorrBj13]+(rougth[i]*rougth[i]-rougth[LcorrBj13]*rougth[LcorrBj13])*DL*DL)/(rougth[LcorrBj13]*rougth[LcorrBj13]*l[LcorrBj13]+(rougth[i]*rougth[i]-rougth[LcorrBj11]*rougth[LcorrBj13])*DL);
         }
      }
   
      if (bindl4=='y') {
         if (bindl0N4=='y') l[LcorrBj14]=l[LcorrBj24];
         double DL;
         DL=(rougth[LcorrBj14]!=rougth[LcorrBj24]) ? l[LcorrBj24]/2*(1+sqrt(1+4*pow(l[LcorrBj14]/l[LcorrBj24],2)*(l[LcorrBj24]/l[LcorrBj14]-1)/(rougth[LcorrBj24]/rougth[LcorrBj14]-1))) : 0;
         for (i = lowl1;i >= higl1 ;i-=2) {
            l[i]=(rougth[LcorrBj14]*rougth[LcorrBj14]*l[LcorrBj14]*l[LcorrBj14]+(rougth[i]*rougth[i]-rougth[LcorrBj14]*rougth[LcorrBj14])*DL*DL)/(rougth[LcorrBj14]*rougth[LcorrBj14]*l[LcorrBj14]+(rougth[i]*rougth[i]-rougth[LcorrBj14]*rougth[LcorrBj14])*DL);
         }
      }
   
      for (i = 0;i <= pocet+1;i++) {
         n[i] = Complex(1-delta[i]*dens[i],-beta[i]*dens[i]);
      }
      X *= (jedn == 'v') ? M_PI/648000 : M_PI/180;   // prevod z vterin na rad
      switch (drscanu) {
         case 'm': 
            {
               res = JJ(X,th);        //omega  scan
            }
            break;
         case 'f': 
            {
               res = JJ(X-offset,X); //offset  scan
            }
            break;
         case 't': 
            {
               res = JJ(omega,X);     //2theta scan  
            }
            break;
      }
      if (logfit == 'g') res = log10(res);
   
   
      return res;
   }



   void TMyMarq::Residue ( datafloat& Res, int& Suc,
                     datafloat *X, datafloat *Y, datafloat *Vaha, parfloat *B )
   {
   // Vraci hodnotu Res rezidualniho souctu ctvercu r'.r pro dane b;
   //  (' zde i v dalsim znaci transpozici). Dale spocte vektor residui R
      int I=0;
      datafloat sum, moc, disp;
      Res=0; sum=0; Suc=1; ++cresid;
      while (Suc && ( I<n_dat ))
      {
         _Indx_Mr=(++I);
         D0[I] = FitFun(X[I],B,Suc); cfitfun++;
         //save pro num. derivaci. Jede i ve FormMat!!!
         R[I]=D0[I]-Y[I];
      //   _MarqRez[I]=R[I];
         moc = Vaha[I]*(-R[I]+iback/iprim);
         sum += moc;
         Res += Vaha[I]*(R[I]*R[I]);
      }
   
      if (logfit != 'g') {
         if (backfit == 'y') iback = (sum>=0) ? iprim*sum/sumavah : 0;
         if (iback < lback) iback=lback;
         if (iback > hback) iback=hback;
      
         disp = Res/(NumDat-NumPar);
         cout<<"Backround = "<<iback;
         if (backfit=='y') cout<<" +- "<<sqrt(disp/sumavah)*iprim<<"\n";
         else cout<<"\n";
      }
   
   }


#ifdef __TURBOC__
   void grafi(double th0,double thmax,double logmin,double logmax)
   {
   
      double s;
      char text[60];
   //-----------------Inicializace grafiky --------------------------
   
   /* request auto detection */
      int gdriver = DETECT, gmode, errorcode;
   
   /* initialize graphics mode */
      initgraph(&gdriver, &gmode, ".");
   
   /* read result of initialization  */
      errorcode = graphresult();
   
      if (errorcode != grOk)  /* an error occurred */
      {
         printf("Graphics error: %s\n", grapherrormsg(errorcode));
         printf("Press any key to halt:");
         getch();
         exit(1);             /* return with error code */
      }
   // ----------------------Konec inicializace ---------------------------
   
   // Osy grafu
      for (s = 0; s < 1; s+=0.001) putpixel(s*getmaxx(),getmaxy(),15);
      for (s = 0; s < 1; s+=0.001) putpixel(0,getmaxy()*(1.0-s)/(1.0-0),15);
      for (s = 0; s < 1; s+=0.01) putpixel(getmaxx()*(thmax-th0)/(thmax-th0)/2,getmaxy()*(1.0-s)/(1.0-0),2);
      for (s = 0; s < 1; s+=0.01) putpixel(getmaxx()*(begf-th0)/(thmax-th0),getmaxy()*(1.0-s)/(1.0-0),2);
      for (s = 0; s < 1; s+=0.01) putpixel(getmaxx()*(endf-th0)/(thmax-th0),getmaxy()*(1.0-s)/(1.0-0),2);
   //   for (s = 0; s < 1; s+=0.01) putpixel(getmaxx()*(10-th0)/(thmax-th0),getmaxy()*(1.0-s)/(1.0-0),2);
   
      char uhl_jedn[3];
      sprintf(uhl_jedn,"%s",(jedn=='v') ? "\"" : "deg");
      sprintf(text,"%1.2lf%s",th0,uhl_jedn);
      outtextxy(0.03*getmaxx(),0.98*getmaxy(),text);
      sprintf(text,"%1.2lf%s",thmax,uhl_jedn);
      outtextxy(0.90*getmaxx(),0.98*getmaxy(),text);
      sprintf(text,"thi");
      outtextxy(0.85*getmaxx(),0.98*getmaxy(),text);
      sprintf(text,"10^%1.1lf",logmin);
      outtextxy(0.005*getmaxx(),0.95*getmaxy(),text);
      sprintf(text,"10^%1.1lf",logmax);
      outtextxy(0.005*getmaxx(),0.01*getmaxy(),text);
      sprintf(text,"R");
      outtextxy(0.01*getmaxx(),0.05*getmaxy(),text);
      sprintf(text,"Omega scan by multilayer with rough interfaces");
      outtextxy(0.2*getmaxx(),0.03*getmaxy(),text);
      sprintf(text,"Number of layers %1.0d",pocet);
      outtextxy(0.2*getmaxx(),0.05*getmaxy(),text);
      sprintf(text,"Divergency primary beam %1.3lf%s",diver,uhl_jedn);
      outtextxy(0.2*getmaxx(),0.07*getmaxy(),text);
      sprintf(text,"Scaling exponent h=%1.2lf ",h);
      outtextxy(0.2*getmaxx(),0.09*getmaxy(),text);
   /*
   setcolor(14);
   sprintf(text,"J = f(thi) %1.0lf%s< th <%1.0lf%s",th0,uhl_jedn,thmax,uhl_jedn);
   outtextxy(0.5*getmaxx(),0.2*getmaxy(),text);
   */
   
   }

   void grafe()
   {
   // -------------- Uzavreni grafiky ----------------------
      getch();
      closegraph();
   // --------------Uzaveni grafiky ---------------------------
   }
#endif


   void simulace(double th0,double thmax,double logmin,double logmax)
   {
      int i;
      double x, s;
      datafloat thi, pom, posuv_thi, thrad;
      double step = (thmax-th0)/nsteps;
      FILE *fr;
   
      if (out == 'y') fr = fopen(soubor,"w");
   
      for (i = 0;i <= pocet+1;i++) {
         n[i] = Complex(1-delta[i]*dens[i],-beta[i]*dens[i]);
      }
      for (thi = th0;thi <= thmax;thi+=step) {
         thrad = (jedn == 'v') ? thi*M_PI/648000 : thi*M_PI/180;   // prevod z vterin na rad
         switch (drscanu) {
            case 'm': 
               {
                  pom = JJ(thrad,th);
               }
               break;
            case 'f': 
               {
                  pom = JJ(thrad-offset,thrad); //offset  scan
               }
               break;
            case 't': 
               {
                  pom = JJ(omega,thrad);     //2theta scan
               }
               break;
         }
      
         if (sum=='y' && fit=='n') {
            s = 0;
            for (i = 1;i<=16;i++) {
               x = rand();
               x /= 32767;
               s += x;
            }
            s = sqrt(iprim*pom/ips)*(s-8)+iprim*pom; //int. doba = 25*vzork. doba
            pom = (s > 0)  ? s/iprim : pom;
         }
      
         posuv_thi = (dopad=='n') ? thi-thd : thi;
      
         if (out == 'y') fprintf(fr,"%8.3lf %10.15lf\n",posuv_thi,pom);
      	#ifdef __TURBOC__
         if (pom>0)
            putpixel((thi-th0)/(thmax-th0)*getmaxx(),getmaxy()*(logmax-log10(fabs(pom)))/(logmax-logmin),14);
         else
            putpixel((thi-th0)/(thmax-th0)*getmaxx(),getmaxy()*(logmax-log10(fabs(pom)))/(logmax-logmin),13);
         #endif
         #ifndef __TURBOC__
         printf("%lf (%lf,%lf) \r",thi,th0,thmax);
         #endif
      
      }
      if (out == 'y') fclose(fr);
   }


   void simmap(double qxmin,double qxmax,double qxstep,double qzmin,double qzmax,double qzstep)
   {
      int i;
      double qx, qz;
      double x, s;	
      datafloat thi, ths, pom;
      FILE *fr;
   
      fr = fopen(soubor,"w");
   
      for (i = 0;i <= pocet+1;i++) {
         n[i] = Complex(1-delta[i]*dens[i],-beta[i]*dens[i]);
      }
      for (qz = qzmin;qz <= qzmax;qz+=qzstep) {
         for (qx = qxmin;qx <= qxmax;qx+=qxstep) {
            ths=asin(sqrt(qx*qx+qz*qz)/2/K);
            thi=ths+asin(qx/sqrt(qx*qx+qz*qz));
            if (thi>0 && thi<2*ths) pom = JJ(thi,ths);
            else pom = 0;         
         
            if (sum=='y' && fit=='n') {
               s = 0;
               for (i = 1;i<=16;i++) {
                  x = rand();
                  x /= 32767;
                  s += x;
               }
               s = sqrt(iprim*pom/ips)*(s-8)+iprim*pom; //int. doba = 25*vzork. doba
               pom = (s > 0)  ? s/iprim : pom;
            }
         
            fprintf(fr,"%8.6lf %8.6lf %10.15lf\n",qx,qz,pom);
            printf("%lf - %lf, (%lf,%lf) - (%lf,%lf) \r",qx,qz,qxmin,qxmax,qzmin,qzmax);    
         }
         fprintf(fr,"\n");
      }
      fclose(fr);
   }


#ifdef __TURBOC__
   void expdata(double th0,double thmax,double logmin,double logmax,
               datafloat X[PocetDat+1],datafloat Y[PocetDat+1])
   {
      int i;
      switch (logfit) {
         case 'n': 
            {
               for(i = 1;i<=NumDat;i++) {
                  if (Y[i]!=0) putpixel((X[i]-th0)/(thmax-th0)*getmaxx(),getmaxy()*(logmax-log10(Y[i]))/(logmax-logmin),13);
               }
            }
            break;
         case 'g': 
            {
               for(i = 1;i<=NumDat;i++) {
                  putpixel((X[i]-th0)/(thmax-th0)*getmaxx(),getmaxy()*(logmax-Y[i])/(logmax-logmin),13);
               }
            }
            break;
      }
   
   }
#endif


   void main(void)
   {
   
      int i, j, k, ii, jj, kk, c, multi, perioda, multinum;
      int motiv[10];
      double refl, s;
      double thr, thrpom, thr1;   // uhel dopadu
      char ip, cas;
      double intper, intper_1, sqrweight;
      double Xmin, Xmax, Ymin, Ymax;
      double omegashift;
      double begkw, endkw, koefweight;
   
   
      errno = 0;
   
   
   //=================Nacitani vstupnich  hodnot ==============================
   
      FILE *fr, *fw;
      fr = fopen("xfit.inp","r");
      if (errno != 0) {printf("No such input file:"); exit(1);}
   
      while ((c = getc(fr)) != '$')
         ;                     	    // nacitani hodnot ze souboru
      fscanf(fr,"%lf", &iprim);           // Intenzita primaru
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf %lf %lf", &iback, &lback, &hback);// Intenzita pozadi
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &backfit);          // Fitovat pozadi
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &diver);              // Divergence primaru
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &omegashift);       //Posun uhlu dopadu (omega korekce vzhledem k 0)
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &bx);              // Rozmer paprsku x
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &by);              // Rozmaer paprsku y
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &bd);              // Posun paprsku od osy goniometru
      bx1=bx/2+bd; 
      bx2=bx/2-bd;
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &slit);            // Sirka sterbiny
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &analyz);              // Detektor analyzator
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &apertura);        // Vstupni apertura detektoru
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &dist);            // Vzdalenost sterbiny od vzorku
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &sx);              // Rozmer vzorku x
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &sy);              // Rozmer vzorku y
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &sd);              // Posun vzorku sd od stredu
      sx1=sx/2+sd; 
      sx2=sx/2-sd;
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &cent);              // vzdalenost povrchu vzorku od osy goniometru (rozjustovani)
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &lambda);          // Vln. delka
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &x2data);             //Vstupni data z programu X2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%s", inpfile);           // Nazev vstupniho souboru s exp. daty
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &in);              // Vstupni data
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%s", soubor);           // Nazev vystupniho souboru
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &out);              // Vystup do souboru
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &PocetDat);              // Pocet merenych dat
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &fit);              // Provest fitovani
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &logfit);              // Fitovat logaritmus
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &simmapy);              // Simulace mapy
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &qxmin);          // Meze osy QX
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &qxmax);          // Meze osy QX
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &qxstep);          // krok QX
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &qzmin);          // Meze osy QZ
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &qzmax);          // Meze osy QZ
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &qzstep);          // krok QZ
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &sum);              // Zasumet data
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &ips);              // Int. doba pro sum
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &ip);              // Nacitat int. dobu
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &cas);              // Cas nebo int. doba
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &begkw);          // Pocatek oboru multiplikace vahy
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &endkw);          // Konec oboru multiplikace vahy
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &koefweight);      // Multiplikator vahy
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &sqrweight);       //Exponent vahy (koef*ip/intensita)^sqrweight
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &jedn);              // Uhlove jednotky
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &begf);          // Pocatek oboru fit. dat
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &endf);          // Konec oboru fit. dat (ve vt.)
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &begf1);          // Pocatek oboru fit. dat
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &endf1);          // Konec oboru fit. dat (ve vt.)
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &Xmin);          // Meze osy X
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &Xmax);          // Meze osy X
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &nsteps);          // pocet bodu
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &Ymin);          // Meze osy Y
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &Ymax);          // Meze osy Y
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &drscanu);          //Druh simulovaneho scanu
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &th);          //Specularni poloha v omega scanu
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &dopad);          //uhel dopadu ano ne
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &offset);          //Offset omega
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &omega);          //Omega v 2theta scanu
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &specdif);          // Spekularni, difuzni rozptyl ano-ne
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &cor);              // Druh kovariance
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &h);          //staticky skalovaci exponent
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &Lk);          // Vertikalni kor. delka
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &chirepl);          // Smer replikace
      chirepl *= M_PI/180;   // prevod z st na rad
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &semi);          //Semikinematicka aproximace
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &bindsqrtr);       // Svazat drsnost odmocninovou zavislosti
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &lowr);          //dolni mez svazane drsnosti 1
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &higr);          //horni mez svazane drsnosti 2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &RoughBj1);          //index fitovane drsnosti1
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &RoughBj2);          //index fitovane drsnosti2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &bindr0N);        //svazat drsnost rozhrani 1 s drsnosti 2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &bindsqrtr2);       // Svazat drsnost odmocninovou zavislosti
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &lowr2);          //dolni mez svazane drsnosti 1
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &higr2);          //horni mez svazane drsnosti 2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &RoughBj12);          //index fitovane drsnosti1
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &RoughBj22);          //index fitovane drsnosti2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &bindr0N2);        //svazat drsnost rozhrani 1 s drsnosti 2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &bindsqrtr3);       // Svazat drsnost kazdeho 2. rozhrani odmocninovou zavislosti
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &lowr3);          //dolni mez svazane drsnosti 1
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &higr3);          //horni mez svazane drsnosti 2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &RoughBj13);          //index fitovane drsnosti1
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &RoughBj23);          //index fitovane drsnosti2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &bindr0N3);        //svazat drsnost rozhrani 1 s drsnosti 2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &bindsqrtr4);       // Svazat drsnost kazdeho 2. rozhrani odmocninovou zavislosti
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &lowr4);          //dolni mez svazane drsnosti 1
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &higr4);          //horni mez svazane drsnosti 2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &RoughBj14);          //index fitovane drsnosti1
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &RoughBj24);          //index fitovane drsnosti2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &bindr0N4);        //svazat drsnost rozhrani 1 s drsnosti 2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &bindl1);       // Svazat korr delku 
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &lowl1);          //dolni mez svazane kor. delky 1
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &higl1);          //horni mez svazane kor. delky 2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &LcorrBj11);          //index fitovane kor. delky1
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &LcorrBj21);          //index fitovane kor. delky2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &bindl0N1);        //svazat kor. delku 1 s kor. delkou 2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &bindl2);       // Svazat korr delku 
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &lowl2);          //dolni mez svazane kor. delky 1
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &higl2);          //horni mez svazane kor. delky 2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &LcorrBj12);          //index fitovane kor. delky1
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &LcorrBj22);          //index fitovane kor. delky2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &bindl0N2);        //svazat kor. delku 1 s kor. delkou 2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &bindl3);       // Svazat korr delku 
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &lowl3);          //dolni mez svazane kor. delky 1
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &higl3);          //horni mez svazane kor. delky 2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &LcorrBj13);          //index fitovane kor. delky1
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &LcorrBj23);          //index fitovane kor. delky2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &bindl0N3);        //svazat kor. delku 1 s kor. delkou 2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &bindl4);       // Svazat korr delku 
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &lowl4);          //dolni mez svazane kor. delky 1
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &higl4);          //horni mez svazane kor. delky 2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &LcorrBj14);          //index fitovane kor. delky1
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &LcorrBj24);          //index fitovane kor. delky2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &bindl0N4);        //svazat kor. delku 1 s kor. delkou 2
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &fitpergam);              // Fitovat jednou periodu a pomer tloustek
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &perind);          //poradi fitovaneho parametru periody 
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &gammaind);          //poradi fitovaneho parametru pomeru tloustek
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%c", &disperiod);         // zavest poruchu periodicity
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &tl1);          //poradi prvni porusene vrstvy
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &tl2);          //poradi posledni porusene vrstvy
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &deld1);          //porucha (prirustek) dolni vrstvy periody
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%lf", &deld2);          //porucha (prirustek) horni vrstvy periody
      while ((c = getc(fr)) != '$')
         ;
      fscanf(fr,"%d", &POCET);          // Max. pocet vrstev
   
   
      if ((fitr = (charvector) malloc(sizeof(int)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((fitl = (charvector) malloc(sizeof(int)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((fitd = (charvector) malloc(sizeof(int)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((fitdns = (charvector) malloc(sizeof(int)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((mfit = (intmat) malloc(sizeof(int *)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      for(i=0; i<POCET+1; i++) {
         if ((mfit[i]= (int *) malloc(sizeof(int)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}}
      for(i=0; i<POCET+1; i++) {
         for(j=0; j<POCET+2; j++) mfit[i][j]=0;
      }
      if ((d = (dvector) malloc(sizeof(double)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((dmin = (dvector) malloc(sizeof(double)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((dmax = (dvector) malloc(sizeof(double)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((dens = (dvector) malloc(sizeof(double)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((densmin = (dvector) malloc(sizeof(double)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((densmax = (dvector) malloc(sizeof(double)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((delta = (dvector) malloc(sizeof(double)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((beta = (dvector) malloc(sizeof(double)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((rougth = (dvector) malloc(sizeof(double)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((rougmin = (dvector) malloc(sizeof(double)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((rougmax = (dvector) malloc(sizeof(double)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((l = (dvector) malloc(sizeof(double)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((lmin = (dvector) malloc(sizeof(double)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((lmax = (dvector) malloc(sizeof(double)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((z = (dvector) malloc(sizeof(double)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((n = (cvector) malloc(sizeof(Complex)*(POCET+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      if ((MEMI = (intmat) malloc(sizeof(int *)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      for(i=0; i<=POCET; i++) {
         if ((MEMI[i]= (int *) malloc(sizeof(int)*17)) == NULL) {printf("Allocation error \n"); exit(1);}}
      if ((MEM = (complmat) malloc(sizeof(Complex *)*(POCET+1))) == NULL) {printf("Allocation error \n"); exit(1);}
      for(i=0; i<=POCET; i++) {
         if ((MEM[i]= (Complex *) malloc(sizeof(Complex)*17)) == NULL) {printf("Allocation error \n"); exit(1);}}
   
      delta[0]=beta[0]=0;
      for (i=0;i<=9;i++) perbeg[i]=perend[i]=0;
      k = 0; kk = 4; //k-poradi fitovaneho par. kk-nacitaneho par.
      i = 0; multi=0; multinum=0;
      do {
         do {c=getc(fr);} while(c != '$' && c != '\\' && c!='}')
         ;
         if (c=='}') {
            i++;  // i - poloha dane vrstvy v celem systemu
            perioda=i-multi; //perioda - pocet vrstev v periode 
            for (jj=1;jj<motiv[multinum];jj++) {
               for (ii=1;ii<=perioda;ii++) {
                  delta[i]=delta[i-perioda];
                  beta[i]=beta[i-perioda];
                  rougth[i-1]=rougth[i-perioda-1];
                  l[i-1]=l[i-perioda-1];
                  dens[i]=dens[i-perioda];
                  d[i]=d[i-perioda];
                  mfit[j-perioda+ii][jj]=i;
                  i++;
               }
            }
            i--;
            do {c=getc(fr);} while(c != '$' && c != '\\' && c!='}')
            ;
            perend[multinum]=(i-perbeg[multinum]+1)/motiv[multinum]+perbeg[multinum]-1; // perend - poloha posledni vrstvy ve stacku
         }
         if (c=='\\') {
            multinum++; //pocitadlo nove multivrstvy v systemu
            while ((c = getc(fr)) != '(')
               ;
            fscanf(fr,"%d", &motiv[multinum]);   //motiv - pocet opakovani stacku
            multi=i+1;       // multi - poloha aktualni multivrstvy od zacatku
            perbeg[multinum]=i+1;     // perbeg - poloha prvni vrstvy ve stacku
            while ((c = getc(fr)) != '$')
               ;
         }
         fscanf(fr,"%d", &j);  //j - poradi (input) dane vrstvy - zadavano
         i++;
         mfit[abs(j)][0]=i;  // spojuje poradi vrstvy v inputu s celkovym poradim v systemu
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%lf %lf", &delta[i], &beta[i]);
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%lf %lf %lf", &rougth[i-1], &rougmin[i-1], &rougmax[i-1]);
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%c",&fitr[i-1]);
         if (fitr[i-1] == 'y') {
            k++;
            B[k] = rougth[i-1];
            Bmin[k] = rougmin[i-1];
            Bmax[k] = rougmax[i-1];
            pfit[k] = kk;
         }
         kk++;
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%lf %lf %lf", &l[i-1], &lmin[i-1], &lmax[i-1]);
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%c",&fitl[i-1]);
         if (fitl[i-1] == 'y') {
            k++;
            B[k] = l[i-1];
            Bmin[k] = lmin[i-1];
            Bmax[k] = lmax[i-1];
            pfit[k] = kk;
         }
         kk++;
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%lf %lf %lf", &dens[i], &densmin[i], &densmax[i]);
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%c",&fitdns[i]);
         if (fitdns[i] == 'y') {
            k++;
            B[k] = dens[i];
            Bmin[k] = densmin[i];
            Bmax[k] = densmax[i];
            pfit[k] = kk;
         }
         kk++;
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%lf %lf %lf", &d[i], &dmin[i], &dmax[i]);
         while ((c = getc(fr)) != '$')
            ;
         fscanf(fr,"%c",&fitd[i]);
         if (fitd[i] == 'y') {
            k++;
            B[k] = d[i];
            Bmin[k] = dmin[i];
            Bmax[k] = dmax[i];
            pfit[k] = kk;
         }
         kk++;
      } while (j >= 0);
      pocet= i-1;     // Pocet vrstev
      NumPar = k;
      fclose(fr);
   
      stackmax=2;  //maximalni poradi hlavni multivrstvy
      stack1 = (multinum < stackmax)? multinum : stackmax;
   
      substd1 = mfit[(int)pfit[perind]/4][0];
      substd2 = mfit[(int)pfit[gammaind]/4][0];
   
      if (fitpergam=='y') {
         double b1=B[perind]+B[gammaind]; //+di substd1-B[perind] substd2-B[gammaind]
         for (i=perbeg[stack1];i<=substd1-1;i++) b1+=d[i];
         for (i=substd1+1;i<=substd2-1;i++) b1+=d[i];
         for (i=substd2+1;i<=perend[stack1];i++) b1+=d[i];
         double b2=B[perind]/b1;
         //cout<<B[perind]<<" "<<B[gammaind]<<" "<<b1<<" "<<b2<<" "<<"\n";
         B[perind]=b1;
         B[gammaind]=b2;
         //cout<<perind<<" "<<gammaind<<" "<<perbeg<<" "<<substd1<<" "<<substd2<<" "<<perend<<"\n";   
      }
   
      // B[i] obsahuje stale tloustky s presnou periodou
      if (disperiod=='y') {    //Odstraneni opravy tloustek na posun v periode      
         for (j = 0; j<=(perend[stack1]-perbeg[stack1]);j++) { // <- cykl pres vrstvy v jedne periode
            for (i = tl1-j; i >= tl2-j+(perend[stack1]-perbeg[stack1]);i-=(perend[stack1]-perbeg[stack1]+1)) d[i]=d[tl1-j]+(tl1-i-j)/2*(((int)(j/2)==j/2)? deld1:deld2);
         }
      }
   
      if (bindsqrtr=='y') {
         if (lowr>pocet) lowr=pocet;
         if (higr<0) higr=0;
         if (RoughBj1>lowr) RoughBj1=lowr;
         if (RoughBj2<higr) RoughBj2=higr;
         if (RoughBj2>=RoughBj1) {printf("Sigind2>=Sigind1->exit \n"); exit(1);}
         if (bindr0N=='y') rougth[RoughBj1]=rougth[RoughBj2];
         double DDj=0;
         for (i = pocet;i >= (RoughBj1+1) ;i--) DDj=DDj+d[i];
         double DD0=DDj;
         for (i = (RoughBj1);i >= (RoughBj2+1) ;i--) DD0=DD0+d[i]; //polohy fitovanych drsnosti
         double DD=0;
         for (i = pocet;i >= (lowr+1) ;i--) DD=DD+d[i];
         for (i = lowr;i >= (higr+1) ;i--) {
         //         DD=pocet-i; DD0=pocet;           //svazani drsnosti 1
            rougth[i]=sqrt(cuttozero(rougth[RoughBj1]*rougth[RoughBj1]+(rougth[RoughBj2]*rougth[RoughBj2]-rougth[RoughBj1]*rougth[RoughBj1])*(DD-DDj)/(DD0-DDj)));
            DD=DD+d[i];
         }
         rougth[higr]=sqrt(cuttozero(rougth[RoughBj1]*rougth[RoughBj1]+(rougth[RoughBj2]*rougth[RoughBj2]-rougth[RoughBj1]*rougth[RoughBj1])*(DD-DDj)/(DD0-DDj)));
      }
   
      if (bindsqrtr2=='y') {
         if (lowr2>pocet) lowr2=pocet;
         if (higr2<0) higr2=0;
         if (RoughBj12>lowr2) RoughBj12=lowr2;
         if (RoughBj22<higr2) RoughBj22=higr2;
         if (RoughBj22>=RoughBj12) {printf("Sigind22>=Sigind12->exit \n"); exit(1);}
         if (bindr0N2=='y') rougth[RoughBj12]=rougth[RoughBj22];
         double DDj=0;
         for (i = pocet;i >= (RoughBj12+1) ;i--) DDj=DDj+d[i];
         double DD0=DDj;
         for (i = (RoughBj12);i >= (RoughBj22+1) ;i--) DD0=DD0+d[i]; //polohy fitovanych drsnosti
         double DD=0;
         for (i = pocet;i >= (lowr2+1) ;i--) DD=DD+d[i];
         for (i = lowr2;i >= (higr2+1) ;i--) {
         //         DD=pocet-i; DD0=pocet;           //svazani drsnosti 1
            rougth[i]=sqrt(cuttozero(rougth[RoughBj12]*rougth[RoughBj12]+(rougth[RoughBj22]*rougth[RoughBj22]-rougth[RoughBj12]*rougth[RoughBj12])*(DD-DDj)/(DD0-DDj)));
            DD=DD+d[i];
         }
         rougth[higr2]=sqrt(cuttozero(rougth[RoughBj12]*rougth[RoughBj12]+(rougth[RoughBj22]*rougth[RoughBj22]-rougth[RoughBj12]*rougth[RoughBj12])*(DD-DDj)/(DD0-DDj)));
      }
   
      if (bindsqrtr3=='y') {
         if (lowr3>pocet) lowr3=pocet;
         if (higr3<0) higr3=0;
         if (RoughBj13>lowr3) RoughBj13=lowr3;
         if (RoughBj23<higr3) RoughBj23=higr3;
         if (RoughBj23>=RoughBj13) {printf("Sigind23>=Sigind13->exit \n"); exit(1);}
         if (fmod(lowr3-higr3,2)!=0) {printf("lowr3-higr3 must be odd\n"); exit(1);}
         if (bindr0N3=='y') rougth[RoughBj13]=rougth[RoughBj23];
         double DDj=0;
         for (i = pocet;i >= (RoughBj13+1) ;i--) DDj=DDj+d[i];
         double DD0=DDj;
         for (i = (RoughBj13);i >= (RoughBj23+1) ;i--) DD0=DD0+d[i]; //polohy fitovanych drsnosti
         double DD=0;
         for (i = pocet;i >= (lowr3+1) ;i--) DD=DD+d[i];
         for (i = lowr3;i >= (higr3+1) ;i-=2) {
         //         DD=pocet-i; DD0=pocet;           //svazani drsnosti 1
            rougth[i]=sqrt(cuttozero(rougth[RoughBj13]*rougth[RoughBj13]+(rougth[RoughBj23]*rougth[RoughBj23]-rougth[RoughBj13]*rougth[RoughBj13])*(DD-DDj)/(DD0-DDj)));
            DD=DD+d[i]+d[i-1];
         }
         rougth[higr3]=sqrt(cuttozero(rougth[RoughBj13]*rougth[RoughBj13]+(rougth[RoughBj23]*rougth[RoughBj23]-rougth[RoughBj13]*rougth[RoughBj13])*(DD-DDj)/(DD0-DDj)));
      }
   
      if (bindsqrtr4=='y') {
         if (lowr4>pocet) lowr4=pocet;
         if (higr4<0) higr4=0;
         if (RoughBj14>lowr4) RoughBj14=lowr4;
         if (RoughBj24<higr4) RoughBj24=higr4;
         if (RoughBj24>=RoughBj14) {printf("Sigind24>=Sigind14->exit \n"); exit(1);}
         if (fmod(lowr4-higr4,2)!=0) {printf("lowr4-higr4 must be odd\n"); exit(1);}
         if (bindr0N4=='y') rougth[RoughBj14]=rougth[RoughBj24];
         double DDj=0;
         for (i = pocet;i >= (RoughBj14+1) ;i--) DDj=DDj+d[i];
         double DD0=DDj;
         for (i = (RoughBj14);i >= (RoughBj24+1) ;i--) DD0=DD0+d[i]; //polohy fitovanych drsnosti
         double DD=0;
         for (i = pocet;i >= (lowr4+1) ;i--) DD=DD+d[i];
         for (i = lowr4;i >= (higr4+1) ;i-=2) {
         //         DD=pocet-i; DD0=pocet;           //svazani drsnosti 1
            rougth[i]=sqrt(cuttozero(rougth[RoughBj14]*rougth[RoughBj14]+(rougth[RoughBj24]*rougth[RoughBj24]-rougth[RoughBj14]*rougth[RoughBj14])*(DD-DDj)/(DD0-DDj)));
            DD=DD+d[i]+d[i-1];
         }
         rougth[higr4]=sqrt(cuttozero(rougth[RoughBj14]*rougth[RoughBj14]+(rougth[RoughBj24]*rougth[RoughBj24]-rougth[RoughBj14]*rougth[RoughBj14])*(DD-DDj)/(DD0-DDj)));
      }
   
      if (bindl1=='y') {
         if (lowl1>pocet) lowl1=pocet;
         if (higl1<0) higl1=0;
         if (LcorrBj11>lowl1) LcorrBj11=lowl1;
         if (LcorrBj21<higl1) LcorrBj21=higl1;
         if (LcorrBj21>=LcorrBj11) {printf("Lind21>=Lind11->exit \n"); exit(1);}
         if (bindl0N1=='y') l[LcorrBj11]=l[LcorrBj21];
         double DL;
         DL=(rougth[LcorrBj11]!=rougth[LcorrBj21]) ? l[LcorrBj21]/2*(1+sqrt(1+4*pow(l[LcorrBj11]/l[LcorrBj21],2)*(l[LcorrBj21]/l[LcorrBj11]-1)/(rougth[LcorrBj21]/rougth[LcorrBj11]-1))) : 0;
         for (i = lowl1;i >= higl1 ;i--) {
            l[i]=(rougth[LcorrBj11]*rougth[LcorrBj11]*l[LcorrBj11]*l[LcorrBj11]+(rougth[i]*rougth[i]-rougth[LcorrBj11]*rougth[LcorrBj11])*DL*DL)/(rougth[LcorrBj11]*rougth[LcorrBj11]*l[LcorrBj11]+(rougth[i]*rougth[i]-rougth[LcorrBj11]*rougth[LcorrBj11])*DL);
         }
      }
   
      if (bindl2=='y') {
         if (lowl2>pocet) lowl2=pocet;
         if (higl2<0) higl2=0;
         if (LcorrBj12>lowl2) LcorrBj12=lowl2;
         if (LcorrBj22<higl2) LcorrBj22=higl2;
         if (LcorrBj22>=LcorrBj12) {printf("Lind22>=Lind12->exit \n"); exit(1);}
         if (bindl0N2=='y') l[LcorrBj12]=l[LcorrBj22];
         double DL;
         DL=(rougth[LcorrBj12]!=rougth[LcorrBj22]) ? l[LcorrBj22]/2*(1+sqrt(1+4*pow(l[LcorrBj12]/l[LcorrBj22],2)*(l[LcorrBj22]/l[LcorrBj12]-1)/(rougth[LcorrBj22]/rougth[LcorrBj12]-1))) : 0;
         for (i = lowl1;i >= higl1 ;i--) {
            l[i]=(rougth[LcorrBj12]*rougth[LcorrBj12]*l[LcorrBj12]*l[LcorrBj12]+(rougth[i]*rougth[i]-rougth[LcorrBj12]*rougth[LcorrBj12])*DL*DL)/(rougth[LcorrBj12]*rougth[LcorrBj12]*l[LcorrBj12]+(rougth[i]*rougth[i]-rougth[LcorrBj12]*rougth[LcorrBj12])*DL);
         }
      }
   
      if (bindl3=='y') {
         if (lowl3>pocet) lowl3=pocet;
         if (higl3<0) higl3=0;
         if (LcorrBj13>lowl3) LcorrBj13=lowl3;
         if (LcorrBj23<higl3) LcorrBj23=higl3;
         if (LcorrBj23>=LcorrBj13) {printf("Lind23>=Lind13->exit \n"); exit(1);}
         if (bindl0N3=='y') l[LcorrBj13]=l[LcorrBj23];
         double DL;
         DL=(rougth[LcorrBj13]!=rougth[LcorrBj23]) ? l[LcorrBj23]/2*(1+sqrt(1+4*pow(l[LcorrBj13]/l[LcorrBj23],2)*(l[LcorrBj23]/l[LcorrBj13]-1)/(rougth[LcorrBj23]/rougth[LcorrBj13]-1))) : 0;
         for (i = lowl1;i >= higl1 ;i-=2) {
            l[i]=(rougth[LcorrBj13]*rougth[LcorrBj13]*l[LcorrBj13]*l[LcorrBj13]+(rougth[i]*rougth[i]-rougth[LcorrBj13]*rougth[LcorrBj13])*DL*DL)/(rougth[LcorrBj13]*rougth[LcorrBj13]*l[LcorrBj13]+(rougth[i]*rougth[i]-rougth[LcorrBj11]*rougth[LcorrBj13])*DL);
         }
      }
   
      if (bindl4=='y') {
         if (lowl4>pocet) lowl4=pocet;
         if (higl4<0) higl4=0;
         if (LcorrBj14>lowl4) LcorrBj14=lowl4;
         if (LcorrBj24<higl4) LcorrBj24=higl4;
         if (LcorrBj24>=LcorrBj14) {printf("Lind24>=Lind14->exit \n"); exit(1);}
         if (bindl0N4=='y') l[LcorrBj14]=l[LcorrBj24];
         double DL;
         DL=(rougth[LcorrBj14]!=rougth[LcorrBj24]) ? l[LcorrBj24]/2*(1+sqrt(1+4*pow(l[LcorrBj14]/l[LcorrBj24],2)*(l[LcorrBj24]/l[LcorrBj14]-1)/(rougth[LcorrBj24]/rougth[LcorrBj14]-1))) : 0;
         for (i = lowl1;i >= higl1 ;i-=2) {
            l[i]=(rougth[LcorrBj14]*rougth[LcorrBj14]*l[LcorrBj14]*l[LcorrBj14]+(rougth[i]*rougth[i]-rougth[LcorrBj14]*rougth[LcorrBj14])*DL*DL)/(rougth[LcorrBj14]*rougth[LcorrBj14]*l[LcorrBj14]+(rougth[i]*rougth[i]-rougth[LcorrBj14]*rougth[LcorrBj14])*DL);
         }
      }
   
   
   //==============Konec nacitani vstupnich hodnot==========================
   
      z[0]=0;            //Vypocet polohy rozhrani
      for (i = 0; i<pocet;i++) {
         z[i+1] = z[i]+d[i+1];
      }
   
      K = 2*M_PI/lambda;
   
      if (analyz == 'n')
         apertura = slit/dist*(dist-sx1/2)/(dist-sx1+(sx1*sx1-slit*slit)/4/dist);
      else
         apertura *= (jedn == 'v') ? M_PI/648000 : M_PI/180;   // prevod z vt/st na rad
   
      for (i = 0;i <= pocet+1;i++) {
         n[i] = Complex(1-delta[i]*dens[i],-beta[i]*dens[i]);
      }
   
      thd = th;
      th *= (jedn == 'v') ? M_PI/648000 : M_PI/180;   // prevod z vt/st na rad
      offsetd = offset;
      offset *= (jedn == 'v') ? M_PI/648000 : M_PI/180;   // prevod z vt/st na rad
      omegad = omega;
      omega *= (jedn == 'v') ? M_PI/648000 : M_PI/180;   // prevod z vt/st na rad
      divrad = (jedn == 'v') ? diver*M_PI/648000 : diver*M_PI/180; // prevod z vt/st na rad
   
      if (analyz == 'y') {
         tha = divrad*divrad+apertura*apertura;
         thb = 1;
      //  thb = divrad*apertura*sqrt(M_PI/tha);
      }
      else {
         tha = atan(fabs(bx1+bx2-slit)/2/dist);
         thb = atan(fabs(bx1+bx2+slit)/2/dist); // shape of specular beam assumed symmetric far from sample
      }
   
   
      if (in == 'y') {
      //========================Nacitani merenych dat ===========================
      
         if ((X = (datafloat *) malloc(sizeof(float)*(PocetDat+2))) == NULL) {printf("Allocation error \n"); exit(1);}
         if ((Y = (datafloat *) malloc(sizeof(float)*(PocetDat+2))) == NULL) {printf("Allocation error \n"); exit(1);}
         if ((Vaha = (datafloat *) malloc(sizeof(float)*(PocetDat+2))) == NULL) {printf("Allocation error \n"); exit(1);}
      
         fr = fopen(inpfile,"r");
         if (errno != 0) {printf("No such data file:"); exit(1);}
      
         if (x2data == 'y') { 
            while ((c = getc(fr)) != '$')
               ;
            for (i=1;i<4;i++) {
               fscanf(fr,"%s\n",string); }
         }
      
         i=0; intper_1 = 0;
         while (feof(fr) == 0) {
            i++;
            switch (ip) {
               case 'y': fscanf(fr,"%22e %22e %22lf \n", &X[i], &Y[i], &intper);
                  break;
               case 'n': fscanf(fr,"%22e %22e \n", &X[i], &Y[i]);
                  break;
            }
            switch (logfit) {
               case 'n': Vaha[i] = (Y[i] != 0) ? 1/Y[i] : 0;
                  if (ip == 'y') {
                     Vaha[i] *= (cas == 'c') ? intper-intper_1 :intper;
                     intper_1 = intper;
                  }
                  else  {
                     refl = Y[i]*iprim;
                     if (refl <= 1000) {Vaha[i] *= 1;}
                     if (refl <= 100) {Vaha[i] *= 1;}
                     if (refl <= 10) {Vaha[i] *= 1;}
                  }
                  Y[i] = Y[i]/iprim;
                  break;
               case 'g': 
                  {Vaha[i] = (Y[i] != 0) ? 1 : 0;
                  //          refl = Y[i]*iprim;
                     Y[i] = (Y[i] != 0) ? log10(Y[i]/iprim) : Ymin-log10(iprim);}
                  break;
            }
            if (dopad == 'n') X[i]+=thd;
            if ((X[i]<begf || X[i]>endf)&&(X[i]<begf1 || X[i]>endf1)) Vaha[i] *= 0;  // vzorku se neuvazuje
            if (X[i]>begkw & X[i]<endkw)  Vaha[i]*=koefweight;
            Vaha[i]=pow(Vaha[i],sqrweight);
            X[i]=X[i]+omegashift;
         }
         NumDat = i-1;      // Pocet fitovanych dat
         fclose(fr);
      
         sumavah=0;        //Vypocet sumy vah
         for (i=1; i<=NumDat; i++) sumavah+=Vaha[i];
      
      
         #ifdef __TURBOC__
      	grafi(X[1],X[NumDat],Ymin,Ymax);
      	#endif
         simulace(X[1],X[NumDat],Ymin,Ymax);
      	#ifdef __TURBOC__
         expdata(X[1],X[NumDat],Ymin,Ymax,X,Y);
         grafe();
      	#endif
      }
      else {
         if (simmapy=='y')	   
            simmap(qxmin,qxmax,qxstep,qzmin,qzmax,qzstep);
         else 
         {
            #ifdef __TURBOC__
               grafi(Xmin,Xmax,Ymin,Ymax);
            #endif
            simulace(Xmin,Xmax,Ymin,Ymax);
         	#ifdef __TURBOC__
               expdata(Xmin,Xmax,Ymin,Ymax,X,Y);
               grafe();
           	#endif
         }
      }
   
   
      if (fit == 'y' && in == 'y') {
      
         cout<<"NUMERICAL derivation is used\n\n";
         //cout << "Press any key...\n"; getch();
      
      // ============== fitovani pres potomka TMyMarq ==========
      
         TMyMarq *MyMarq;
         MyMarq = new TMyMarq ("trace.dat",1);  // inicializace fit. objektu
      // tez by to slo inicializovat  MyMarq = new TMyMarq ();
      
      // ted to nafituj
         MyMarq->Marq
            ( NumDat , X,Y,Vaha, NumPar/*pocet parametru*/, B,Bmin,Bmax, SumR, Eval, KolikPrint );
      // v B jsou odhadnute parametry
         UkazVysledky(MyMarq);
      //  celkchyby(MyMarq);
         delete MyMarq;  // zavola si destructor
      // uz jsem to nafitoval a zjistil vsechny stat. udaje
      
         //cout << "Press any key...\n"; getch();
      
         #ifdef __TURBOC__
         grafi(X[1],X[NumDat],Ymin,Ymax);
      	#endif
         simulace(X[1],X[NumDat],Ymin,Ymax);
      	#ifdef __TURBOC__
         expdata(X[1],X[NumDat],Ymin,Ymax,X,Y);
         grafe();
      	#endif
      }
   
   
      if (fit == 'y' && in !='y') cout<<"Input data have not been read";
   
      double DD;
      fw = fopen("struct.out","w");
      fprintf(fw,"num. position    roughness  corr.l.   thickness   density    delta      beta\n",pocet+1, dens[pocet+1]);
      fprintf(fw,"%d   subs        not        not       inf       %8.3lf    %8.3e  %8.3e\n",pocet+1, dens[pocet+1], delta[pocet+1]*dens[pocet+1], beta[pocet+1]*dens[pocet+1]);
      DD=0;
      for (i = pocet;i >= 1 ;i--) {
         fprintf(fw,"%d   %8.3lf   %8.3lf   %8.3lf    %8.3lf  %8.3lf    %8.3e  %8.3e\n", i, DD, rougth[i], l[i], d[i], dens[i], delta[i]*dens[i], beta[i]*dens[i]);
         DD=DD+d[i];
      }
      fprintf(fw,"%d   %8.3lf   %8.3lf   %8.3lf    inf    %8.3lf    %8.3e  %8.3e\n", i, DD, rougth[0], l[0], dens[0], delta[0]*dens[0], beta[0]*dens[0]);
      fclose(fw);
   
      eldensityprof(pocet,d,dens,delta,rougth);
   
      free(fitr); free(fitd); free(fitdns); free(mfit); free(d); free(dmax); free(dmin); 
      free(dens); free(densmax); free(densmin); free(delta); free(beta);
      free(rougth); free(rougmax); free(rougmin); free(n);
   }
